using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace VC.NET
{
    public partial class SignalBox : Form
    {
        static int videotype, scanlines, fieldfrq;
        static short iSubCode;

        Int64 lSubStandard; //added on 20140422
        JHI.okApi okDevice;

        public SignalBox()
        {
            InitializeComponent();
        }

        public void SetDevice(JHI.okApi okDev)
        {
            okDevice = okDev;
        }

        private void SignalBox_Load(object sender, EventArgs e)
        {
			String	str;
			int		extsign=0,vidcolor=-1;
			int		ret;
            String  boardname = "";
			/*BOOL	IsCameraDll();
             */

            lSubStandard = okDevice.SetVideoParam(JHI.VideoParam.VIDEO_TVSTANDARD, -1);
            lSubStandard = okDevice.SetVideoParam(JHI.VideoParam.VIDEO_TVSTANDARD, ((UInt16)(lSubStandard) | 30<<16));
            Thread.Sleep(100);

			if (lSubStandard !=-1) // not support this fun yet
				TURNTVSTANDARD.Enabled = false; //disable


			okDevice.GetTypeCode(ref boardname);
			str = "ǰƵϢ" + "     (" + boardname + ")";
			Text = str;

            AutoSearch.Enabled = true;

			extsign = okDevice.GetSignalParam(JHI.SignalParam.SIGNAL_VIDEOEXIST);
			if(extsign==1) {
                str = "⵽źԴ ";
			}
			else if(extsign==0) {
                str = "ûźԴ ";
			}
			else {//-1
                str = "֧ ";
				AutoSearch.Enabled = false;

			}

			vidcolor = okDevice.GetSignalParam(JHI.SignalParam.SIGNAL_VIDEOCOLOR);
			if(extsign==1) {
				
				if(vidcolor==1)
					str = str + "(Color)";
				else if(vidcolor==0)
					str = str + "(B/W)";
			}
            VideoExist.Text = str;


			//video type
			if(extsign==1) {
				okDevice.WaitSignalEvent(JHI.EventParam.EVENT_ODDFIELD, 40);
				videotype = okDevice.GetSignalParam(JHI.SignalParam.SIGNAL_VIDEOTYPE);
				if(videotype==1) //interlaced
                    str = "ź(Interlaced)";
				else if(videotype==0) //non-interlaced
                    str = "ź(Progressive)";
				else if(videotype==-1)
                    str = "֧ ";
				
			}
			else 
                str = "δ֪";
		
			VideoType.Text = str;

			//video scanlines
			scanlines = -1;
			if (extsign == 1) { 
				scanlines = okDevice.GetSignalParam(JHI.SignalParam.SIGNAL_SCANLINES);
                if (scanlines == -1)
                    str = "֧ ";
                else
                {
                    str = scanlines.ToString() + "/";
                }
			}
			else
                str = "δ֪";
			Scanlines.Text = str;

			//video field frequency
			if (extsign == 1) {
				fieldfrq = okDevice.GetSignalParam(JHI.SignalParam.SIGNAL_FIELDFREQ);
				if (fieldfrq == -1)
                    str = "δ֪";
				else {
                    str = fieldfrq.ToString() + "/";
				}
			}
			else if(extsign==-1) 
				str = "δ֪";
            FrameFreq.Text = str;


			//extern trigger
			ret = okDevice.GetSignalParam(JHI.SignalParam.SIGNAL_EXTTRIGGER);


			if (ret == -1)
				str = "֧ ";
			else if (ret != 0)
				str = "״̬";
			else
				str = "޴";
			ret = okDevice.GetSignalParam(JHI.SignalParam.SIGNAL_CAPFINISHED);
			if (ret != -1) { //supported
				if (ret == 1)
					str = str + ";      Captured";
				else
					str = str + ";      No Captured";
			}
            ExtTrigger.Text = str;

            SampleRatio43.Checked = true;
			//firstly assume that can not detect signal infos
            SetVideo.Enabled = false;

            AutoFineSet.Enabled = false;
            SampleRatio43.Enabled = false;
            SampleRatio11.Enabled = false;
			if (scanlines != -1){
                SetVideo.Enabled = true;
                AutoFineSet.Enabled = true;
                SampleRatio43.Enabled = true;
                SampleRatio11.Enabled = true;
			}

			//test out trigger
			okDevice.PutSignalParam(JHI.PutSignalParam.PUTSIGNAL_TRIGGER, 0xff);

			//enable vert sync
			okDevice.PutSignalParam(JHI.PutSignalParam.PUTSIGNAL_VERTSYNC, 0x1);
        }

        private void TURNTVSTANDARD_Click(object sender, EventArgs e)
        {
			long	lParam;	
			String	str;

//			ShowWindow(GetDlgItem(hDlg,IDC_TURNTVSTANDARD),SW_SHOW);

			iSubCode++;
			lParam = okDevice.SetVideoParam(JHI.VideoParam.VIDEO_TVSTANDARD, -1);
			lParam = ((UInt16)lParam) | ((UInt16)iSubCode << 16);
			if (okDevice.SetVideoParam(JHI.VideoParam.VIDEO_TVSTANDARD, lParam) == -1){ //reach maximum
				iSubCode = 1;
				lParam = (Convert.ToUInt16(lParam) | (Convert.ToUInt16(iSubCode) << 16));
				okDevice.SetVideoParam(JHI.VideoParam.VIDEO_TVSTANDARD, lParam);
			}
			str ="T: " + iSubCode.ToString();
            TURNTVSTANDARD.Text = str;
        }

        private void AutoFineSet_Click(object sender, EventArgs e)
        {
            /*if (bDispToScreen) //added on 20200413
                okStopCapture(hBoard);
            //SendMessage(hWnd,WM_COMMAND,IDM_FREEZE,0);
             */

            //SetCursor(hAppStart);
            okDevice.AutoSetCapRect(0, 0); //full auto-fine-set 
            //exAllocateDIBMemory(hBoard); //may be re-new size
            //SetCursor(hArrow);

            this.Close();

        }
    }
}