using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;
using System.IO;

namespace VC.NET
{
    public partial class main : Form
    {
        public const int NUMINFILE = 100;

        //ί
        JHI.BeginCapture BegCapture;
        JHI.ProcCapture ProCapture;
        JHI.EndCapture EndCapture;

        //
        public JHI.okApi okDevice = new JHI.okApi();
        Int32 bActive = 0; //=0 stoped, -1 capbybuffer, =1,2 real to screen
        //short total = 2;
        Int64 iCurrUsedNo = -1;//	
        Int64 intrMISCCONTROL; //b0:1

        Int32 bScrnCenter = 0; //non-centerize
        long lScrnOffset;
        Int32 sampwidth, sampheight;		//width x height
//        Int32 horzstart, vertstart;			//horz start, vert start

        Int32 bMatchClient = 0; // match client rect
        Int32 bMakeMirror = 0; //no mirror
        int iClientWidth;
        int iClientHeight;

        short bMaskMode = 0; // mask disable

//        String seqfile = "ok.seq";
        UInt32 dwMaxMemSize;
        UInt32 dwDIBCurrSize = 1024 * 1024 * 4; //
        UInt64 dwBufSize;

//        long lStartImage = 0;  //added on 20180104
//        long lNumImage = NUMINFILE;

        WINAPI.BITMAPINFOHEADER bi;
        //IntPtr lpbi;
        IntPtr lpdib = IntPtr.Zero;
        IntPtr lpMemory = IntPtr.Zero; //for memory to capture by buffer
        //BLOCKINFO blkinfo;

        //LPDIBINFO lpDibPlay;	//for ReplayDlg
        Int32 bDispToScreen;

        //long		elapsed;
        long		numframe;
        long		bufform;
        JHI.BLOCKINFO	blk = new JHI.BLOCKINFO();
        long		num;
        float		ratio=25;

        //audio.c
        long elapsedtimes;

        //COkDevice okDevice = new COkDevice();
        //okDevice = new OKAPI.okApi();
        public static ushort LOWORD(uint value) 
        {
            return (ushort)(value & 0xFFFF);
        }
        public static ushort LOWORD(long value)
        {
            return (ushort)(value & 0xFFFF);
        }
        public static ushort HIWORD(uint value) 
        {
            return (ushort)(value >> 16);
        }
        public static ushort HIWORD(long value)
        {
            return (ushort)(value >> 16);
        }
        public static byte LOWBYTE(ushort value)
         {
            return (byte)(value & 0xFF);
        }
        public static byte HIGHBYTE(ushort value) 
        {
            return (byte)(value >> 8);
        }

        public main()
        {
            InitializeComponent();
        }

        private void main_Load(object sender, EventArgs e)
        {
            BegCapture = Begin;
            ProCapture = Process;
            EndCapture = End;

            exGetInitSet();

            WINAPI.IniFile.WritePrivateProfileString(("Route"), ("Created Win"), (""), ("OkDemo.ini"));
            exOpenCard();
            okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_MIRROR, bMakeMirror);
            exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
            lpdibPainttoScreen();
        }

        private void main_FormClosed(object sender, FormClosedEventArgs e)
        {
            
            exCloseThisBoard();
            Marshal.FreeHGlobal(lpdib);
            lpdib = IntPtr.Zero;
            Marshal.FreeHGlobal(lpMemory);
            lpMemory = IntPtr.Zero;
            
            exSaveInitSet(bScrnCenter);
             
        }

        private void main_Paint(object sender, PaintEventArgs e)
        {
         /*   
            int x = LOWORD((uint)lScrnOffset);
            int y = HIWORD((uint)lScrnOffset);

            if (lpdib != IntPtr.Zero)
            {
                e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                e.Graphics.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality;
                {
                    Bitmap image;
                    if (bi.biBitCount == 24)
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format24bppRgb, lpdib);
                    else
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format32bppRgb, lpdib);
                    image.RotateFlip(RotateFlipType.RotateNoneFlipY);
                    e.Graphics.DrawImage(image, x, y);
                }
            }*/
        }
        

        //File
        private void FileLoadFile_Click(object sender, EventArgs e)
        {
            exLoadImageFile();

            sampwidth = (short)bi.biWidth;
            sampheight = (short)bi.biHeight;
            lScrnOffset = exSetToWndRectEx(bScrnCenter);

            exAllocateDIBMemory(); //may be re-new size
           
            lpdibPainttoScreen();
            exDisplayDIBInfo();
        }

        private void FileSaveScreen_Click(object sender, EventArgs e)
        {
            exSaveScreenFile();
        }

        private void FileSaveBuffer_Click(object sender, EventArgs e)
        {
            exSaveBufferFile();
        }

        private void FileCopyToClipb_Click(object sender, EventArgs e)
        {
            if (lpdib != IntPtr.Zero)
            {
                {
                    Bitmap image;
                    if (bi.biBitCount == 24)
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format24bppRgb, lpdib);
                    else
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format32bppRgb, lpdib);
                    image.RotateFlip(RotateFlipType.RotateNoneFlipY);
                    Clipboard.SetImage(image);
                }
            }
        }

        private void FileSetToZero_Click(object sender, EventArgs e)
        {
            //clear screen dib and buffer 0
            IntPtr lpLinear;
            short height = 0;
            short width = 0;
            Int64 stride = 0;
            int i;

            if (bi.biHeight != 0)
            {
                for (i = 0; i < bi.biSizeImage; i++)
                    Marshal.WriteByte((IntPtr)(lpdib.ToInt64() + i), 0);
            }

            lpLinear = okDevice.GetTargetInfo(JHI.TARGET.BUFFER, 0, ref width, ref height, ref stride);

            if (lpLinear != IntPtr.Zero)
            {
                for (i = 0; i < stride * height; i++)
                    Marshal.WriteByte((IntPtr)(lpLinear.ToInt64() + i), 0);
            }
            exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
            SetBlockInfo();
            PainttoScreen(0);
        }

        bool SetBlockInfo()
        {
            blk.iType = (short)JHI.ConstParam.BMPHEADER.GetHashCode();  //data is dib format
            blk.lpBits = lpdib;
            blk.iBitCount = (short)bi.biBitCount;

            blk.iWidth = (short)bi.biWidth;

            if (okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_SAMPLEFIELD, -1) == 0) //sample in field by field
                if (LOWORD(okDevice.SetVideoParam(JHI.VideoParam.VIDEO_SIGNALTYPE, -1)) == 1) //interlace video
                    if (okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_FIELDEXTEND, -1) != 0)
                        bi.biHeight *= 2; //double size for ht

            blk.iHeight = (short)-bi.biHeight; //note: minus is for invert dib in y by ConvertRect
            return true;
        }

        private void FileSetToBand_Click(object sender, EventArgs e)
        {
            //set gray and color bands to dib and buffer 0
            {
                IntPtr lpLinear;
                short height = 0, width = 0;
                Int64 stride = 0;
                JHI.BLOCKINFO blk = new JHI.BLOCKINFO();

                lpLinear = okDevice.GetTargetInfo(JHI.TARGET.BUFFER, 0, ref width, ref height, ref stride);
                if ((lpLinear != IntPtr.Zero) && (bi.biBitCount != 24))
                {
                    exSetTestBands(lpLinear, (short)(stride / width * 8), height, stride); //buffer
                    exSetDataToDIB(JHI.TARGET.BUFFER, 0, bi, lpdib);
                }
                else
                { //dib is 24 bits mode
                    //set dib first
                    exSetTestBands(lpdib, (short)bi.biBitCount, (short)bi.biHeight, bi.biSizeImage / bi.biHeight);
                    exConvertBitmap(bi, lpdib);

                    //get image to app buffer from tgt
                    blk.lpBits = lpdib;
                    blk.iWidth = (short)bi.biWidth;
                    blk.iHeight = (short)-bi.biHeight; //!!!to invert y
                    blk.iBitCount = (short)bi.biBitCount;
                    blk.lBlockStep = (short)bi.biSizeImage; //must be set
                    blk.iHiStep = (short)main.HIWORD(bi.biSizeImage);
//                    if (bi.biCompression == BI_BITFIELDS)
                    {//
/*                        DWORD* lpMask;
                        lpMask = (DWORD*)((LPBYTE)lpbi + lpbi->biSize);
                        if (lpMask[1] == 0x03e0) //555
                            blk.iFormType = FORM_RGB555;
                        else if (lpbi->biBitCount == 16)
                            blk.iFormType = FORM_RGB565;
                        else if (lpbi->biBitCount == 32)
                            blk.iFormType = FORM_RGB8888;*/
                    }

                    okDevice.ConvertRect(JHI.TARGET.BUFFER, 0, ref blk, 0, 1);
                }
            }
            PainttoScreen(0);
        }

        private void FileLoadConfigFile_Click(object sender, EventArgs e)
        {
            exLoadCfgFile();

            InitSetMenu();

            exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi); //set-lpbi
            //get current size  
            sampwidth = (short)bi.biWidth;
            sampheight = (short)bi.biHeight;
            lScrnOffset = exSetToWndRectEx(bScrnCenter);

            exAllocateDIBMemory(); //may be re-new size
            lpdibPainttoScreen();

        }

        private void FileSaveConfigFile_Click(object sender, EventArgs e)
        {
            exSaveCfgFile();
        }

        private void FileExitOkdemo_Click(object sender, EventArgs e)
        {
            Close();
        }

        //Option
        private void OptionEnableMask_Click(object sender, EventArgs e)
        {
            if (OptionEnableMask.Checked)
            {
                OptionEnableMask.Checked = false;
                bMaskMode = 0; //disable mask
            }
            else
            {
                OptionEnableMask.Checked = true;
                bMaskMode = 1; //positive mask
            }
            okDevice.EnableMask(bMaskMode); //set mask
        }

        private void OptionNormainLut_Click(object sender, EventArgs e)
        {
            exFillInputLUT(0);
        }

        private void OptionBufferToScreen_Click(object sender, EventArgs e)
        {
            exSetDataToDIB(JHI.TARGET.BUFFER, 0, bi, lpdib);
            Refresh();
        }

        private void OptionScreenToBuffer_Click(object sender, EventArgs e)
        {
            JHI.BLOCKINFO blkinfo = new JHI.BLOCKINFO();

            blkinfo.lpBits = lpdib;
            blkinfo.iBitCount = (short)bi.biBitCount;
            blkinfo.iWidth = (short)bi.biWidth;
            blkinfo.iHeight = (short)-bi.biHeight;

            okDevice.ConvertRect(JHI.TARGET.BUFFER, 0, ref blkinfo, 0, 1);
        }

        private void OptionBuffer0ToBuffer1_Click(object sender, EventArgs e)
        {
            okDevice.TransferRect(JHI.TARGET.BUFFER, 1, JHI.TARGET.BUFFER, 0, 1);
        }

        private void OptionBuffer1ToBuffer0_Click(object sender, EventArgs e)
        {
            okDevice.ConvertRect(JHI.TARGET.BUFFER, 0, JHI.TARGET.BUFFER, 1, 1);
        }

        private void OptionBufferToFrame_Click(object sender, EventArgs e)
        {
            Freeze.Enabled = true;
            if (okDevice.TransferRect(JHI.TARGET.FRAME, 0, JHI.TARGET.BUFFER, 0, 1) > 0) //fast or hard
            {
                Thread.Sleep(80);
            }
            else
                okDevice.ConvertRect(JHI.TARGET.FRAME, 0, JHI.TARGET.BUFFER, 0, 1);
        }

        private void OptionFrameToBuffer_Click(object sender, EventArgs e)
        {
            if (okDevice.GetTypeCode(0) == JHI.TypeCode.OK_RGB30.GetHashCode())
                okDevice.TransferRect(JHI.TARGET.BUFFER, 0, JHI.TARGET.FRAME, 0, 1);
            else //just for C70 with frame in board
                okDevice.ConvertRect(JHI.TARGET.BUFFER, 0, JHI.TARGET.FRAME, 0, 1);

        }

        private void OptionFrameToScreen_Click(object sender, EventArgs e)
        {
            if (okDevice.GetTypeCode(0) == JHI.TypeCode.OK_RGB30.GetHashCode())
                okDevice.TransferRect(JHI.TARGET.SCREEN, 0, JHI.TARGET.FRAME, 0, 1);
            else if (okDevice.ConvertRect(JHI.TARGET.SCREEN, 0, JHI.TARGET.FRAME, 0, 1) > 0)
            {
                //take buffer size
                exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
                exSetDataToDIB(JHI.TARGET.SCREEN, 0, bi, lpdib);
            }

        }

        private void OptionSelectCard_Click(object sender, EventArgs e)
        {
            SelectBox select = new SelectBox();

            select.SetCurrUsedNo(iCurrUsedNo);
            select.ShowDialog();
            if (iCurrUsedNo != select.GetCurrUsedNo())
            {
                exCloseThisBoard();
                iCurrUsedNo = select.GetCurrUsedNo();
                exOpenCard();
                bActive = 0;
                lScrnOffset = exSetToWndRectEx(bScrnCenter);
                exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
                lpdibPainttoScreen();
            }
        }

        //capture
        private void CaptureCapToBuffer_Click(object sender, EventArgs e)
        {

        }

        private void CaptureCapToMemory_Click(object sender, EventArgs e)
        {
            if (CaptureBackToScreen.Checked)
                bDispToScreen = 1;
            else
                bDispToScreen = 0;
            //
            //okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,1);
            Freeze_Click(sender, e);
            Freeze.Enabled = true;
            okDevice.SetSeqCallback(BegCapture, ProCapture, EndCapture);

            int num;
            JHI.BLOCKINFO blk = new JHI.BLOCKINFO();

            blk.iType = (short)JHI.ConstParam.BLKHEADER.GetHashCode(); ;
            blk.lpBits = lpMemory;

            // just change buffer to supported, if it is now not supported 
            okDevice.CaptureTo(JHI.TARGET.BUFFER, -1, 0); // not really to capture
            num = Convert.ToInt32(dwMaxMemSize/exGetFrameSize());
            Marshal.WriteInt32(lpMemory, 0);
            //okCaptureByBuffer(hBoard,(TARGET)lpMemory,0,num);
            if (num>0)
                okDevice.CaptureByBuffer(ref blk, 0, num);
        }

        private void CaptureCapToSeqFile_Click(object sender, EventArgs e)
        {
            if (CaptureBackToScreen.Checked)
                bDispToScreen = 1;
            else
                bDispToScreen = 0;
            //
            //okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,1);
            Freeze_Click(sender, e);
            Freeze.Enabled = true;
            okDevice.SetSeqCallback(BegCapture, ProCapture, EndCapture);

            String szFileName = "";

            if (!exGetSaveName(ref szFileName))
                return;

            SetSeqFileNumBox seqBox = new SetSeqFileNumBox();
	        if( seqBox.ShowDialog() == DialogResult.OK ) {
                long	quality=0;	

                //if( !stricmp(strrchr(szFileName,'.'),".jpg") ) //jpg
                if (string.Equals(Path.GetExtension(szFileName), ".jpg", StringComparison.OrdinalIgnoreCase))
                    quality = 50;
                okDevice.CaptureByBufferEx(quality, szFileName, 0, seqBox.GetFileNum());
            }
            else {
                Freeze.Enabled = false;
            }
        }
        //ʵʱ
        private void CaptureCapToInDirect_Click(object sender, EventArgs e)
        {
            CaptureCapToInDirect.Checked = true;
            CaptureInterToInDirect.Checked = false;
			
			Freeze_Click(sender, e);

			Freeze.Enabled = true;

			//restore to normal (system palette)
			okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_PALETTE, 0);
			Int64 lret = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_MISCCONTROL, -1) & ~0x3;
			okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_MISCCONTROL, lret); //normal

			//okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,3); //normal

			//way 2 can support menu overlay, but too slow for NT 
			bDispToScreen = 2;;
				//just capture to buffer
            okDevice.SetSeqCallback(BegCapture, ProCapture, EndCapture);
			
			if( okDevice.CaptureByBuffer(JHI.TARGET.BUFFER,0,0) == (IntPtr)1) //0: cont.
				//no enough buffer.
				MessageBox.Show("\n This need at least two frame size! \n\t\t Try to increase bigger size of BUFFER .",
                    " No enough BUFFER can be used ", System.Windows.Forms.MessageBoxButtons.OK);
        }

        private void CaptureContToBuffer0_Click(object sender, EventArgs e)
        {
            Freeze.Enabled = true;
            okDevice.CaptureTo(JHI.TARGET.BUFFER, 0, 0);
            if (CaptureBackToScreen.Checked)
                bDispToScreen = 1;
            else
                bDispToScreen = 0;
        }

        private void CaptureContToBuffer1_Click(object sender, EventArgs e)
        {
            Freeze.Enabled = true;
            okDevice.CaptureTo(JHI.TARGET.BUFFER, 1, 0);
            if (CaptureBackToScreen.Checked)
                bDispToScreen = 1;
            else
                bDispToScreen = 0;
        }

        private void CaptureCapToFrame_Click(object sender, EventArgs e)
        {
            Freeze.Enabled = true;
            okDevice.CaptureTo(JHI.TARGET.FRAME, 0, 0); //cont.
        }

        //playback
        private void PlaybackDispFromBuffer_Click(object sender, EventArgs e)
        {

        }

        private void PlaybackCapToMonitor_Click(object sender, EventArgs e)
        {
            Freeze.Enabled = true;
            okDevice.CaptureTo(JHI.TARGET.MONITOR, 0, 0);//0: cont.
        }

        private void PlaybackDispFromFrame_Click(object sender, EventArgs e)
        {
            Freeze.Enabled = true;
            okDevice.PlaybackFrom(JHI.TARGET.FRAME, 0, 0); //cont.
        }

        private void PlaybackNormalLut_Click(object sender, EventArgs e)
        {
            exFillOutLUT(0);
        }

        private void PlaybackInverseLut_Click(object sender, EventArgs e)
        {
            exFillOutLUT(1);
        }

        private void PlaybackAbsoluteLut_Click(object sender, EventArgs e)
        {
            exFillOutLUT(2);
        }

        private void PlaybackAbsoluteDsa_Click(object sender, EventArgs e)
        {
            exFillOutLUT(3);
        }

        //Freeze
        private void Freeze_Click(object sender, EventArgs e)
        {
            if (okDevice.isAudioOpen())  //audio capturing
            {
                exEndCaptureAudio();
            }
//            exStopMulCapture(); //to stop in case mul-capturing
            
            okDevice.StopCapture();

            if (bActive != 0)
            {
                //take buffer size
                exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
                exSetDataToDIB(JHI.TARGET.SCREEN, 0, bi, lpdib);
                exDisplayDIBInfo();
            }
            bActive = 0;
            Freeze.Enabled = false;
            Active.Enabled = true;

            okDevice.SetSeqCallback(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero); //confirm to null

        }

        //Single
        private void SingleCap_Click(object sender, EventArgs e)
        {

            Freeze_Click(sender, e);
            
			if ( okDevice.GetTypeCode(0) == JHI.TypeCode.OK_C70.GetHashCode() ) { //to frame
				okDevice.CaptureTo(JHI.TARGET.FRAME, 0, 1);

				if (okDevice.ConvertRect(JHI.TARGET.SCREEN, 0, JHI.TARGET.FRAME, 0, 1)>0) {
					exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi); 
					exSetDataToDIB(JHI.TARGET.SCREEN, 0, bi, lpdib);
				}
			} else { //all other normal grabber device
				long	basetime,elapse,times,times1,times2,lret;
				String	str = "";

				lret = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_TRIGCAPTURE, -1);
				if ( LOWORD((uint)lret)>0 ) {
					str =" Triggered capture mode!   Now waiting for trigger ...";
				}
				else {
					lret = okDevice.SetVideoParam(JHI.VideoParam.VIDEO_SIGNALTYPE, -1);
					if(HIWORD((uint)lret) != 0)
						str = " Video by external trigger!   Now waiting for video of next frame ...";
				}

				Text = str;


				basetime = JHI.okApi.GetTickCount();
				okDevice.CaptureTo(JHI.TARGET.BUFFER, 0, 1);//single
				elapse = JHI.okApi.GetTickCount();
				okDevice.GetCaptureStatus(true);
				
				times = JHI.okApi.GetTickCount();
				//buf->scr
				exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
                exSetDataToDIB(JHI.TARGET.BUFFER, 0, bi, lpdib);
                
				times1 = JHI.okApi.GetTickCount();
                
				lScrnOffset = exSetToWndRectEx(bScrnCenter);
                lpdibPainttoScreen();

				times2 = JHI.okApi.GetTickCount();

				str = " Start=" + (elapse-basetime) +" ms,  Capture=" + (times-elapse) + " ms,  Trans=" + (times1-times) + ",  Paint=" + (times2-times1) + " ms";
				Text = str;

			}

        }

        //Help
        private void HelpSignalInfo_Click(object sender, EventArgs e)
        {
            SignalBox signalInfo = new SignalBox();
            
            if (bActive > 0)
                okDevice.StopCapture();

            signalInfo.SetDevice(okDevice);
            signalInfo.ShowDialog();

            //for autoset
            exAllocateDIBMemory(); //may be re-new size

            exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
            //get current size  
            sampwidth = (short)bi.biWidth;
            sampheight = (short)bi.biHeight;
            lScrnOffset = exSetToWndRectEx(bScrnCenter);
           
            lpdibPainttoScreen();
        }

        private void HelpAbout_Click(object sender, EventArgs e)
        {
            InfoBox infoBox = new InfoBox();
            if (bActive > 0)
                okDevice.StopCapture();
            infoBox.SetDevice(okDevice);
            infoBox.SetMemSize(dwMaxMemSize);
            infoBox.ShowDialog();
        }


        //----------------------- private routines----------
        //--added on 20180202
        //file
        private Boolean exIfSeqFileName(String szFileName)
        {
            if (string.Equals(Path.GetExtension(szFileName), ".seq", StringComparison.OrdinalIgnoreCase) ||
                    string.Equals(Path.GetExtension(szFileName), ".avi", StringComparison.OrdinalIgnoreCase) ||
                    string.Equals(Path.GetExtension(szFileName), ".m2v", StringComparison.OrdinalIgnoreCase) ||
                    string.Equals(Path.GetExtension(szFileName), ".mpg", StringComparison.OrdinalIgnoreCase) ||
                    string.Equals(Path.GetExtension(szFileName), ".mp4", StringComparison.OrdinalIgnoreCase) || //added on 20180201
                    string.Equals(Path.GetExtension(szFileName), ".ts", StringComparison.OrdinalIgnoreCase) ||
                    string.Equals(Path.GetExtension(szFileName), ".h265", StringComparison.OrdinalIgnoreCase)
                )
            {
                return true;
            }
            else
                return false;

        }

        private Boolean exGetSaveName(ref String szFileName)
        {

            saveFileDialog1.Filter = "BMP file (*.BMP)|*.BMP" +
                            "|Jpeg format file (*.JPG)|*.JPG" +
                            "|Sequence file (*.SEQ)|*.SEQ" +
                            "|Sequence file in JPEG (*.SEQ)|*.SEQ" +
					        "|Audio-video interleaved (*.AVI)|*.AVI" +
					        "|Compressed AVI in MJPEG  (*.AVI)|*.AVI" +
					        "|Compressed AVI in H264  (*.AVI)|*.AVI" +
					        "|Compressed AVI in H265  (*.AVI)|*.AVI" +
					        "|MP4 format file (*.mp4)|*.mp4" +
					        "|Jpeg 2000 format file (*.JP2)|*.JP2" +
					        "|TIFF format file (*.TIF)|*.TIF" +
					        "|TS format file (*.ts)|*.TS" +
					        "|Raw format files (*.RAW)|*.RAW";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.DefaultExt = "SEQ";

            if (saveFileDialog1.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return false;

            szFileName = saveFileDialog1.FileName;


	        //changed on 20180202
	        if( exIfSeqFileName(szFileName)	)  {
		        //first delete ok.seq or .avi
                try
                {
                    File.Delete(szFileName);
                }
                //catch (Exception ex)
                catch (Exception)
                {
                }
	        }

	        if(saveFileDialog1.FilterIndex == 4) { //seq file in jpeg data
		        szFileName += ",jpg,50"; //quality=50
	        }
            else if (saveFileDialog1.FilterIndex == 6)
            { //avi in mjpg
                szFileName += ",mjpg,60"; //mjpeg
	        }
            else if (saveFileDialog1.FilterIndex == 7)
            { //avi in mpeg4
                szFileName += ",h264";
	        }
            else if (saveFileDialog1.FilterIndex == 8)
            { //avi in mpeg4
                szFileName += ",h265";
	        }


	        return true;
        }


        //save image in screen as file (support bmp, raw)
        private Boolean exSaveScreenFile()
        {  
	        String		    szFileName = "";
            JHI.BLOCKINFO   blkinfo = new JHI.BLOCKINFO();
            long            lret;

	        if (!exGetSaveName(ref szFileName) )
		        return false;

        	
	        //save current dib
	        blkinfo.iWidth=(short)bi.biWidth;
	        blkinfo.iHeight=(short)bi.biHeight;
	        blkinfo.iBitCount=(short)bi.biBitCount;
	        blkinfo.lpBits=lpdib;
	        //blkinfo.lpExtra=(LPBYTE)lpbi+lpbi->biSize;
            blkinfo.lpExtra = IntPtr.Zero;

	        blkinfo.iFormType=0; //unknown
	        //special for 565
	        if(bi.biBitCount==16) {
		        /*DWORD	*lpMask=(DWORD *)blkinfo.lpExtra;

		        if( lpMask[1]==0x07e0) //565
			        blkinfo.iFormType=FORM_RGB565;
		        else
			        blkinfo.iFormType=FORM_RGB555;*/
	        }

	        //first inverse dib to bitmap
	        exConvertBitmap(bi, lpdib);
	        lret = okDevice.SaveImageFile(szFileName, 0, ref blkinfo, 0, 1);	
	        //restore to dib
	        exConvertBitmap(bi, lpdib);

	        if (lret == 0)
                MessageBox.Show(" Can't save file ?! Try to check media to store. ", "Warning !", System.Windows.Forms.MessageBoxButtons.OK); 
            
	        return true;
        }

        //save image in buffer as file (support bmp, raw, seq)
        private Boolean exSaveBufferFile()
        {
	        String		    szFileName = "";
            JHI.BLOCKINFO   blkinfo = new JHI.BLOCKINFO();
            long            elpased = 0;
	        String		    str;
	        long		    lret = 0;


            if (!exGetSaveName(ref szFileName))
                return false;

	        //changed on 20180202
	        if( exIfSeqFileName(szFileName)	)  {
		        long		total;
        		
		        //save buffer seq
		        total=(short)okDevice.GetBufferSize(IntPtr.Zero, IntPtr.Zero);
		        //how many
                SetSeqFileNumBox seqBox = new SetSeqFileNumBox();
                seqBox.SetFileNum(total);
    	        if( seqBox.ShowDialog() == DialogResult.OK ) {
                    total = seqBox.GetFileNum();

			        elpased = JHI.okApi.GetTickCount();
        	
			        lret = okDevice.SaveImageFile(szFileName, 0, JHI.TARGET.BUFFER, 0, total);	//BUFFER

			        elpased = JHI.okApi.GetTickCount() - elpased;

			        //than set this first block to dib to see what we saved
			        exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi); 
			        exSetDataToDIB(JHI.TARGET.BUFFER, 0, bi, lpdib);
		        }
	        }
	        else { //bmp or other single 
		        if (okDevice.GetBufferSize(IntPtr.Zero, ref dwBufSize) != 0) { //buffer being
			        //how many
                    SetSeqFileNumBox seqBox = new SetSeqFileNumBox();
                    seqBox.SetFileNum(1);
    	            if( seqBox.ShowDialog() == DialogResult.OK ) {

				        elpased = JHI.okApi.GetTickCount();

                        lret = okDevice.SaveImageFile(szFileName, 0, JHI.TARGET.BUFFER, 0, seqBox.GetFileNum());	

				        elpased = JHI.okApi.GetTickCount() - elpased;

				        //then set this first block to dib to see what we saved
				        exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi); 
				        exSetDataToDIB(JHI.TARGET.BUFFER, 0, bi, lpdib);
			        }
		        }
		        else { //no buffer allocated
			        //save current dib
			        blkinfo.iWidth=(short)bi.biWidth;
			        blkinfo.iHeight=(short)bi.biHeight;
			        blkinfo.lBlockStep=0;
			        blkinfo.iHiStep=0;

			        blkinfo.iBitCount=(short)bi.biBitCount;
			        blkinfo.lpBits=lpdib;
			        //blkinfo.lpExtra=(LPBYTE)lpbi+lpbi->biSize;
                    blkinfo.lpExtra = IntPtr.Zero;

			        blkinfo.iFormType=0; //unknown

        			
			        //special for 565
			        if(bi.biBitCount==16) {
				        /*DWORD	*lpMask=(DWORD *)blkinfo.lpExtra;

				        if( lpMask[1]==0x07e0) //565
					        blkinfo.iFormType=FORM_RGB565;
				        else
					        blkinfo.iFormType=FORM_RGB555;*/
			        }

			        //first inverse dib to bitmap
			        exConvertBitmap(bi,lpdib);

			        elpased = JHI.okApi.GetTickCount();

			        lret = okDevice.SaveImageFile(szFileName, 0, ref blkinfo, 0, 1);	
			        elpased = JHI.okApi.GetTickCount() - elpased;

			        //restore to dib
			        exConvertBitmap(bi, lpdib);
		        }
	        }
	        str = " Spent times: " + elpased.ToString() + " ms ";
	        Text = str;

	        if(lret==0)
                MessageBox.Show(" Can't save file ?! Try to check media to store. ", "Warning !", System.Windows.Forms.MessageBoxButtons.OK); 
        	
	        return true;
        }

        private Boolean exLoadCfgFile()
        {
            Boolean bRet;

            openFileDialog1.Filter = "Config file with full params. (*.OKF) |*.OKF|Config file just for sample (*.OKS) |*.OKS|Config file just for output (*.OKO) |*.OKO|CamLink Mode Config File (*.CLF) |*.CLF";
            openFileDialog1.DefaultExt = "okf";
            openFileDialog1.FilterIndex = 1;

            if (openFileDialog1.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return false;
            



            bRet = okDevice.LoadConfigFile(openFileDialog1.FileName);

	        if (!bRet)
	        {
		        Int32	iRet;
		        iRet = JHI.okApi.GetLastError().GetHashCode();
		        MessageBox.Show("load error code = " + iRet.ToString(), "Error", System.Windows.Forms.MessageBoxButtons.OK);
	        }

	        return true;

        }

        Boolean exSaveCfgFile()
        {
            saveFileDialog1.Filter = "Config file with full params. (*.OKF) |*.OKF|Config file just for sample (*.OKS) |*.OKS|Config file just for output (*.OKO) |*.OKO|CamLink Mode Config File (*.CLF) |*.CLF";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.DefaultExt = "okf";

            if (saveFileDialog1.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return false;

            okDevice.SaveConfigFile(saveFileDialog1.FileName);

	        return true;
        }

        //option
        //--demo to fill outlut to these cards with out LUT
        private Int32 exFillInputLUT(short index)
        {
	        short	i,bits,start=0;

	        //check how much bits LUT suppored
	        bits=(short)okDevice.FillInputLUT(IntPtr.Zero, 0, 0);
	        if(bits==-1)
		        return -1; //not support
        	
	        if(	bits<=8) //for 8 bits lut
	        {	
		        Byte[,] bLUT = new Byte[256, 3];
		        short	num=255,gray=256;

		        switch (index) {
			        case 0: //normal
				        for(i=0;i<gray;i++) {
					        bLUT[i, 0]=(Byte)i;
					        bLUT[i, 1]=(Byte)i;
					        bLUT[i, 2]=(Byte)i;
				        }
				        break;
			        case 1: //inverse
				        for(i=0;i<num;i++) {
					        bLUT[i, 0]=(Byte)(num-i);
					        bLUT[i, 1]=(Byte)(num-i);
					        bLUT[i, 2]=(Byte)(num-i);
				        }
				        for(i=num;i<gray;i++) {
					        bLUT[i, 0]=0;
					        bLUT[i, 1]=0;
					        bLUT[i, 2]=0;
				        }
				        break;
			        default:
				        return 0;
		        }
		        okDevice.FillInputLUT(ref bLUT[0, 0], start, gray);	

	        }
	        else { //for great than 8 bits lut
		        ushort[,]	wLUT = new ushort[4096, 3]; //max for 12 bits
		        short	gray;

		        gray = (short)(1<<bits);

		        switch (index) {
			        case 0: //normal
				        for(i=0;i<gray;i++) {
					        wLUT[i, 0] = (ushort)i;
					        wLUT[i, 1] = (ushort)i;
					        wLUT[i, 2] = (ushort)i;
				        }
				        break;
			        case 1: //inverse
				        for(i=0;i<gray;i++) {
					        wLUT[i, 0] = (ushort)(gray-i-1);
					        wLUT[i, 1] = (ushort)(gray-i-1);
					        wLUT[i, 2] = (ushort)(gray-i-1);
				        }
				        break;
			        default:
				        return -1;
		        }
		        okDevice.FillInputLUT(ref wLUT[0, 0], start, gray);	
	        }

	        return 1;
        }

        //playback
        //--demo to fill outlut to these cards with out LUT
        private Int32 exFillOutLUT(short index)
        {
	        short	i,bits,start=0;


	        //check how much bits LUT suppored
	        bits=(short)okDevice.FillOutLUT(IntPtr.Zero, 0, 0);

	        if(	bits<=8) //for 8 bits lut
	        {	
		        Byte[,] bLUT = new Byte[768, 3];
                short[] iLUT = new short[256];
		        short	num=255,gray=256;

		        switch (index) {
			        case 0: //normal
				        for(i=0;i<gray;i++) {
					        bLUT[i, 0]=(Byte)i;
					        bLUT[i, 1]=(Byte)i;
					        bLUT[i, 2]=(Byte)i;
				        }
				        break;
			        case 1: //inverse
				        for(i=0;i<=num;i++) {
					        bLUT[i, 0]=(Byte)(num-i);
					        bLUT[i, 1]=(Byte)(num-i);
					        bLUT[i, 2]=(Byte)(num-i);
				        }
				        for(i=num;i<gray;i++) {
					        bLUT[i, 0]=0;
					        bLUT[i, 1]=0;
					        bLUT[i, 2]=0;
				        }
				        break;
			        case 2: //absolute for M60A
				        for(i=0;i<128;i++) {
					        bLUT[i, 0]=(Byte)(i);
					        bLUT[i, 1]=(Byte)(i);
					        bLUT[i, 2]=(Byte)(i);
				        }
				        for(i=128;i<gray;i++) {
					        bLUT[i, 0]=(Byte)(256-i);
					        bLUT[i, 1]=(Byte)(256-i);
					        bLUT[i, 2]=(Byte)(256-i);
				        }
				        break;

			        case 3: //dsa absolute for M60A
				        //1. take true value with minus
				        for(i=0;i<128;i++) { //>0  0~127
					        iLUT[i]=(Byte)(i);
				        }
				        for(i=128;i<gray;i++) { //<0 -1~-128
					        iLUT[i] = (short)(i-256);
				        }
				        //2. inverse at gray 165
				        for(i=0;i<256;i++) { //37~293
					        iLUT[i] = (short)(165-iLUT[i]);
				        }
				        //3. stretch in several sects 
				        for(i=0;i<256;i++) { //12~245
					        if( iLUT[i]<105) { //12~35
						        iLUT[i]=(short)(0.334*iLUT[i]);
					        }
					        else if( iLUT[i]<165) {//35~150
						        iLUT[i]=(short)(1.916*iLUT[i]-166);
					        }
					        else if( iLUT[i]<205) {//150~245
						        iLUT[i]=(short)(2.38*iLUT[i]-242);
					        }
					        else { //245~255
						        iLUT[i]=(short)(0.113*iLUT[i]+222);
					        }
				        }
				        //4. to lut in byts
				        for(i=0;i<256;i++) { 
					        bLUT[i, 0]=(Byte)iLUT[i];
					        bLUT[i, 1]=(Byte)iLUT[i];
					        bLUT[i, 2]=(Byte)iLUT[i];
				        }
				        break;
			        default:
				        return 0;
		        }
		        okDevice.FillOutLUT(ref bLUT[0, 0], start, gray);	

	        }
	        else { //for great than 8 bits lut
		        ushort[,]	wLUT = new ushort[4096, 3];
		        short	num,gray;

		        gray = (short)(1<<bits);
		        num = (short)(gray-1);
		        switch (index) {
			        case 0: //normal
				        for(i=0;i<gray;i++) {
					        wLUT[i, 0] = (ushort)i;
					        wLUT[i, 1] = (ushort)i;
					        wLUT[i, 2] = (ushort)i;
				        }
				        break;
			        case 1: //inverse
				        for(i=0;i<=num;i++) {
					        wLUT[i, 0] = (ushort)(num-i);
					        wLUT[i, 1] = (ushort)(num-i);
					        wLUT[i, 2] = (ushort)(num-i);
				        }
				        break;
			        default:
				        return -1;
		        }
		        okDevice.FillOutLUT(ref wLUT[0, 0], start, gray);	
	        }

	        return 1;
        }



        //init
        private UInt32 exAllocateDIBMemory()
        {
            Int32 flag = 0;
	        UInt32	dwDIBMemSize = 0;
	        JHI.RECT	rcBuf;

	        if (!okDevice.isOpen())
		        return 0;
            
	        //get current buffer size
            rcBuf.Left = 0;
            rcBuf.Top = 0;
            rcBuf.Right = -1;
            rcBuf.Bottom = -1;
	        okDevice.SetTargetRect(JHI.TARGET.BUFFER, ref rcBuf);
	        dwDIBMemSize = (uint)(((rcBuf.Right+3)*4/4)*rcBuf.Bottom*4) ; // 32  
            
	        if( dwDIBMemSize>dwDIBCurrSize ) {
		        dwDIBCurrSize=dwDIBMemSize;
		        if (lpdib != IntPtr.Zero)
                    Marshal.FreeHGlobal(lpdib);
		        lpdib = IntPtr.Zero;
	        }
            
	        if (bi.biSizeImage > dwDIBCurrSize) {
		        dwDIBCurrSize = bi.biSizeImage;
                if (lpdib != IntPtr.Zero)
                    Marshal.FreeHGlobal(lpdib);
                lpdib = IntPtr.Zero;
            }

            
	        if (lpdib == IntPtr.Zero) {
                lpdib = Marshal.AllocHGlobal((int)dwDIBCurrSize); 
		        flag =1; //changed
	        }
            
	        if (lpdib == IntPtr.Zero) { //no allocated
		        MessageBox.Show("Allocate DIB memory failed !", "Warning", System.Windows.Forms.MessageBoxButtons.OK);
		        return 0;
	        }

	        //GlobalMemoryStatus(&Status);
	        if((flag==1) ) //re-allocated
	        { //changed or init;		
		        if( dwDIBCurrSize<= (4*(1<<20)) ) { //for small than 4M  
			        dwMaxMemSize=dwDIBCurrSize*4;//16M
		        }else { //big dib
			        dwMaxMemSize=dwDIBCurrSize;//
		        }
		        if (lpMemory != IntPtr.Zero)
                    Marshal.FreeHGlobal(lpMemory);

                lpMemory = Marshal.AllocHGlobal((int)dwMaxMemSize);
	        }

	        return (dwDIBCurrSize); //total allocated
        }

        private void exGetInitSet()
        {
            bScrnCenter = WINAPI.IniFile.GetPrivateProfileInt("Init", "Centerize", 1, "OkDemo.ini");

            bMatchClient = WINAPI.IniFile.GetPrivateProfileInt("Init", "MatchClient", 0, "OkDemo.ini");

            iClientWidth = WINAPI.IniFile.GetPrivateProfileInt("Init", "ClientWidth", 0, "OkDemo.ini");
            iClientHeight = WINAPI.IniFile.GetPrivateProfileInt("Init", "ClientHeight", 0, "OkDemo.ini");
        }

        Boolean exSaveInitSet(Int32 bScrnCenter)
        {
	        WINAPI.IniFile.WritePrivateProfileString("Init", "Centerize", bScrnCenter.ToString(), "OkDemo.ini");

	        WINAPI.IniFile.WritePrivateProfileString("Init", "MatchClient",bMatchClient.ToString(), "OkDemo.ini");

	        WINAPI.IniFile.WritePrivateProfileString("Init", "MakeMirror", bMakeMirror.ToString(), "OkDemo.ini");

	        WINAPI.IniFile.WritePrivateProfileString("Init", "ClientWidth", iClientWidth.ToString(), "OkDemo.ini");
	        WINAPI.IniFile.WritePrivateProfileString("Init", "ClientHeight", iClientHeight.ToString(), "OkDemo.ini");
            
	        return true;
        }

        //to open one board as current board to operate
        private Boolean exOpenCard()
        {
            Boolean bRet = false;
            
	        Int32	iNoBoards;
            JHI.ErrorCode error;
	        String	str;


	        //check ok boards sloted in PC
	        iNoBoards = JHI.okApi.GetImageDevice(IntPtr.Zero, IntPtr.Zero);

	        //check if pre_allocated buffer
	        JHI.okApi.GetAvailBuffer(IntPtr.Zero, ref dwBufSize); //whole buffer
            
	        //check if reg device driver for nt/2k/xp 
	        if ( JHI.okApi.SetNTDriver(0) == 0 ) { // TRUE:registered already, -1:not nt system
		        MessageBox.Show("There are not yet registered device service driver!");
	        }
	        //else if( okSetNTDriver(0)==-1 ) { //win95/98
		    //    if( !iNoBoards && (!okSetStaticVxD(0)) ) 
			//        MessageBox(hwnd, "There are not yet registered vxd device driver!","Warning",MB_OK);
	        //}
	        else {
		        if(dwBufSize==0) //may be not reg driver, or no board, ... 
			        MessageBox.Show("There are no buffer pre-allocated !");
	        }


	        WINAPI.IniFile.WritePrivateProfileString("Route","To Open Board","","OkDemo.ini");
	        //open one specified board
	        if ( !okDevice.OpenBoard(iCurrUsedNo) ) {//set 
		        error = JHI.okApi.GetLastError();
		        if (error == JHI.ErrorCode.ERR_NOTFOUNDBOARD) {
			        str = " ErrorCode=" + error.GetHashCode().ToString() + "\n\n Not found correct 'Ok series Image Boards' in this Machine! ";
		        }
		        else {
			        str =" ErrorCode=" + error.GetHashCode().ToString() + "\n\n Open selected board failed! ";
		        }
		        MessageBox.Show(str);
	        }
	        else {
                error = JHI.okApi.GetLastError();
		        if (error == JHI.ErrorCode.ERR_NOTFOUNDVXDDRV) {
                    str = " ErrorCode=" + error.GetHashCode().ToString() + "\n\n Failed to open device driver for Ok Image Board!";
			        MessageBox.Show(str);
		        }
	        }


	        //just starting, then allocated memory for dib
	        {
                exAllocateDIBMemory();

		        if (!okDevice.isOpen())
			        return false;

	        }
            
	        InitSetMenu();
            
	        {
		        Int32	iRet;
		        IntPtr	lpPhys,lpLinear = IntPtr.Zero;

		        lpPhys = JHI.okApi.GetAvailBuffer(ref lpLinear, ref dwBufSize); //total
		        iRet = okDevice.GetTypeCode(-9);
		        //if (sizeof(PVOID) < 8)
		        if (((UInt64)lpPhys > 0xffffffff) && (iRet == 0))
			        MessageBox.Show("The Board could not work in computers with 4GB or more of RAM!");
	        }
            

            return bRet;
        }

        int exCloseThisBoard()
        {
	        UInt32	bSave=1;

	        //okSetVideoParam(hBoard,VIDEO_BRIGHTNESS,10);
	        //okSaveInitParam(hBoard,2);
//	        SendMessage(hwndPlay,WM_COMMAND,IDCANCEL,0);			

	        okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_UPRIGHT, 0); //un
	        okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_MIRROR, 0);

	        if (okDevice.isAudioOpen()) {//audio opened
		        okDevice.CloseAudio();
	        }
	        if (okDevice.isStreamOpen()) {//stream opened
		        okDevice.CloseStream();
	        }
	        //restore interrupt set
	        //okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,intrMISCCONTROL|
	        //		(okSetCaptureParam(hBoard,CAPTURE_MISCCONTROL,-1)&~0x3));



	        if( okDevice.SetDeviceParam(JHI.DeviceParam.DEVICE_GETPARAMCHANGED, 0)>0) {
/*		        char szTitle[MAX_LOADSTRING];
		        char szConfirm[MAX_LOADSTRING];
		        LoadString(hInst, IDS_QUITPARAM, szTitle, MAX_LOADSTRING);
		        LoadString(hInst, IDS_CONFIRM, szConfirm, MAX_LOADSTRING);
		        if( MessageBox((hwnd), szTitle, szConfirm, MB_YESNO)==IDYES) 			
			        bSave=1; */
	        }

	        okDevice.CloseBoardEx(bSave); 

//	        exStopMulCapture(); //to stop in case mul-capturing

	        //okCloseBoard(hBoard); 

	        //MessageBox(NULL,"Close","",MB_OK);

	        //hBoard=0; //confirm set to 0. added on 20190307

	        return 1;
        }

        Boolean InitSetMenu()
        {
	        Int64	typecode;
	        String	okname = "";


	        intrMISCCONTROL = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_MISCCONTROL, -1) & 0x3;
            
	        exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi); //set-lpbi
	        //set initial size
	        sampwidth = (short)bi.biWidth;
	        sampheight = (short)bi.biHeight;
	        //initailize screen
	        lScrnOffset = exSetToWndRectEx(bScrnCenter);
            Refresh();
            
	        //just test
	        okDevice.GetBufferAddr(0);
	        if (okDevice.GetBufferSize(IntPtr.Zero, IntPtr.Zero) <2 ) {
                MessageBox.Show("     Some operation can not run correctly !\n Because BUFFER is not enough for current image size. ", " Warning !", System.Windows.Forms.MessageBoxButtons.OK);
	        }
            
	        {
		        Int64	format = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_SCRRGBFORMAT, -1);
        		
                switch ((JHI.PixelFormat)LOWORD(format))
		        {
			        case 	JHI.PixelFormat.FORM_RGB565:
			        case 	JHI.PixelFormat.FORM_RGB555:
			        //case 	FORM_RGB332:					
				        MessageBox.Show("     Current display mode is 16 bits ! \n\n You should change it to 8, 24 or 32 bits mode", " Warning !", System.Windows.Forms.MessageBoxButtons.OK);
				        break;

		        }
	        }
            
            
	        okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_UPRIGHT, 0); //init to normal 
            OptionUpToRight.Checked = false;
            OptionUpToLeft.Checked = false;

	        okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_MIRROR, 0);//init to normal 
            OptionMakeXMirror.Checked = false;
            OptionMakeYMirror.Checked = false;

            typecode = okDevice.GetTypeCode(ref okname);
	        if (typecode < 0) //virtual 
		        okname = "_" + okname;
	        OKModel.Text = okname;

        	
	        if( okDevice.SetVideoParam(JHI.VideoParam.VIDEO_FRAMELINES,-1)!=-1) { //support playback
                Playback.Enabled = true;

		        if( (okDevice.FillOutLUT(IntPtr.Zero, 0, 0) <=0) || //not suuport outlut
			         (typecode == JHI.TypeCode.OK_M30.GetHashCode()) ) {//special for M30 without outlut
                    PlaybackNormalLut.Enabled = false;
                    PlaybackInverseLut.Enabled = false;
                    PlaybackAbsoluteLut.Enabled = false;
                    PlaybackAbsoluteDsa.Enabled = false;
		        }
	        }
	        else {
                Playback.Enabled = false;
	        }

	        if( okDevice.FillInputLUT(IntPtr.Zero, 0, 0)<=0 ) {
                OptionNormainLut.Enabled = false;
                OptionInverseinLut.Enabled = false;
	        }
	        else {
                OptionNormainLut.Enabled = true;
                OptionInverseinLut.Enabled = true;
	        }


	        //
	        if( (okDevice.FillInputLUT(IntPtr.Zero, 0, 0)>0 ) ||
			        (okDevice.FillOutLUT(IntPtr.Zero, 0, 0)>0) )    //set in &out lut
                OptionFillingLut.Enabled = true;
	        else
                OptionFillingLut.Enabled = false;


	        if( LOWORD((uint)okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_FRMRGBFORMAT,-1)) != 0xffff ) { //support frame
                CaptureCapToFrame.Enabled = true;
                PlaybackDispFromFrame.Enabled = true;
	        }
	        else {
                CaptureCapToFrame.Enabled = false;
                PlaybackDispFromFrame.Enabled = false;
	        }

	        if( okDevice.TransferRect(JHI.TARGET.FRAME, 0, JHI.TARGET.BUFFER, 0, 0) >0 )  { //buffer to frame
                OptionBufferToFrame.Enabled = true;
	        }
	        else {
                OptionBufferToFrame.Enabled = false;
	        }

	        if( okDevice.TransferRect(JHI.TARGET.BUFFER, 0, JHI.TARGET.FRAME, 0, 0) >0 )  { //frame to buffer
                OptionFrameToBuffer.Enabled = true;
                OptionFrameToScreen.Enabled = true;
	        }
	        else {
                OptionFrameToBuffer.Enabled = false;
                OptionFrameToScreen.Enabled = false;
	        }
        	
	        if ( typecode == JHI.TypeCode.OK_M60.GetHashCode() ) { //special for M60 with frame
                CaptureCapToFrame.Enabled = true;
                OptionBufferToFrame.Enabled = true;
	        }
	        else if ( typecode == JHI.TypeCode.OK_RGB30.GetHashCode() ) { //special for RGB30 with frame
                CaptureCapToFrame.Enabled = true;
                OptionFrameToBuffer.Enabled = true;

                OptionFrameToScreen.Enabled = true;
	        }

	        if ( !okDevice.OpenAudio(1)) { //support audio funcrion
                CaptureAudio.Enabled = true;
	        }
	        else {
                CaptureAudio.Enabled = false;
	        }

	        if ( !okDevice.OpenStream(1) ) { //support stream funcrion
                CaptureMpeg2.Enabled = true;
	        }
	        else {
                CaptureMpeg2.Enabled = false;
	        }


	        //reg device driver for nt/2k/xp 
	        if (  JHI.okApi.SetNTDriver(0) != 0) { // TRUE:registered already, -1:not nt system
                HelpRegDevDriver.Enabled = false;
	        }

        	


	        //get current mask mode 
	        bMaskMode = (short)okDevice.EnableMask(-1);
	        if(bMaskMode==-1) {//not support
                OptionEnableMask.Checked = false;
                OptionEnableMask.Enabled = false;
	        }
	        else {
                OptionEnableMask.Enabled = true;
		        if (bMaskMode != 0)//
                    OptionEnableMask.Checked = true;
		        else
                    OptionEnableMask.Checked = false;

		        exDemoMask(bMaskMode);
	        }

	        if( okDevice.CaptureSequence(0, 0) == -1) 
	        {//interrupt to capture
                CaptureSeqCapToBuf.Enabled = false;
                CaptureLoopSeqCapToBuf.Enabled = false;
                CaptureInterToInDirect.Enabled = false;
	        }
	        else {
                CaptureSeqCapToBuf.Enabled = true;
                CaptureLoopSeqCapToBuf.Enabled = true;
                CaptureInterToInDirect.Enabled = true;
	        }



	        //disable active and display sync with vert
	        {
		        Int64	lset;

		        lset = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_MISCCONTROL,-1);
		        if (((lset&0x800000) != 0) || ((lset&0x80) != 0)) //disabled
		        {
                    HelpDisableActive.Checked = true;
		        }
		        else {
                    HelpDisableActive.Checked = false;
		        }


		        lset = okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_NOSYNCSCREEN,-1); //0: sync
		        if (lset != 0) //disabled
		        {
                    HelpDisableSyncVert.Checked = true;
		        }
		        else {
                    HelpDisableSyncVert.Checked = false;
		        }

	        }
        	
	        return true;
        }

        private void MainMenuStrip_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        static UInt32 times;

        //-- calculate capture ratio by counting callback
        float exCalcCaptureRatio()
        {

	        if( (num>=12) ||  ((JHI.okApi.GetTickCount()-times)>2000)&&(num>=2) ) {
		        times = JHI.okApi.GetTickCount()-times;
		        ratio=((float)num*1000/times);
		        num=0;
	        }

	        if(num==0)
		        times = JHI.okApi.GetTickCount();
	        num++;

	        return ratio;
        }

        //ɼʼʱĻص
        public bool Begin(IntPtr hBoard)
        {
            exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
            SetBlockInfo();

//            elapsed = okDevice.GetTickCount();
            numframe = 0;

            num = 0;

            return true;
        }

        /*ɼÿһ֡ͼһλص*/
        public bool Process(IntPtr hBoard, Int64 no, IntPtr imageinfo)
        {
	        Int64	elapsed = 0;

	        numframe++;

	        if (bDispToScreen > 0) {
		        //long	elapsed=okGetTickCount();

		        elapsed=exSetToScreen(no);
		        Text = " Ratio = "  + exCalcCaptureRatio().ToString("F2") + "; Total frames =" + numframe.ToString("D6") + "; Current =" + no.ToString("D6") +";  Paint times=" + elapsed.ToString("D4") + "     ";
	        }
	        else {
		        Text = " Ratio = "  + exCalcCaptureRatio().ToString("F2") + "; Total frames =" + numframe.ToString("D6") + "; Current =" + no.ToString("D6") + " ";
	        }

            return true;
        }

        //--set data to dib in blk by convert
        long exSetToScreen(Int64 no)
        {		
	        long	elapsed;

	        elapsed = JHI.okApi.GetTickCount();

            PainttoScreen(no);

            elapsed = JHI.okApi.GetTickCount() - elapsed;

	        return elapsed;
        }

        bool PainttoScreen(Int64 no)
        {
            int x = LOWORD((uint)lScrnOffset);
            int y = HIWORD((uint)lScrnOffset);
            

            if (lpdib != IntPtr.Zero)
            {
                //e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                //e.Graphics.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality;
                okDevice.ConvertRect(ref blk, 0, JHI.TARGET.BUFFER, no, 1);//MAKELONG(1,2));//1);
                {
                    Bitmap image;
                    if (bi.biBitCount == 24) 
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format24bppRgb, lpdib);
                    else
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format32bppRgb, lpdib);
                    image.RotateFlip(RotateFlipType.RotateNoneFlipY);
                    //e.Graphics.DrawImage(image, x, y);
                    Graphics g = System.Drawing.Graphics.FromImage(image);
                    g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                    g.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality;
                    mShowBox.Left = x;
                    mShowBox.Top = y + 27; ;
                    mShowBox.Width = bi.biWidth;
                    mShowBox.Height = bi.biHeight;
                    mShowBox.Image = image;
                }
            }
            return true;

        }

        bool    lpdibPainttoScreen()
        {
            int x = LOWORD((uint)lScrnOffset);
            int y = HIWORD((uint)lScrnOffset);
            

            if (lpdib != IntPtr.Zero)
            {
                {
                    Bitmap image;
                    if (bi.biBitCount == 24) 
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format24bppRgb, lpdib);
                    else
                        image = new Bitmap((int)bi.biWidth, (int)bi.biHeight, (int)(bi.biSizeImage / bi.biHeight), System.Drawing.Imaging.PixelFormat.Format32bppRgb, lpdib);
                    image.RotateFlip(RotateFlipType.RotateNoneFlipY);
                    //e.Graphics.DrawImage(image, x, y);
                    Graphics g = System.Drawing.Graphics.FromImage(image);
                    g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                    g.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality;
                    mShowBox.Left = x;
                    mShowBox.Top = y + 27; ;
                    mShowBox.Width = bi.biWidth;
                    mShowBox.Height = bi.biHeight;
                    mShowBox.Image = image;
                }
            }
            return true;

        }

        /*ɼص*/
        public bool End(IntPtr hBoard)
        {
            return true;
        }

        ushort exGetBitmapHeader(JHI.TARGET src, ref WINAPI.BITMAPINFOHEADER bi)
        {
	        short		width = 0, height = 0;
	        long		form,extend;


            //take buffer's size and screen' bitcount
	        form = exGetTargetSize(src, ref width, ref height);
	        extend = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_SAMPLEFIELD, -1);
	        if(extend==0) { //in field
		        extend = okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_FIELDEXTEND, -1);
	        }

	        if (src.GetHashCode() <= 1) {
		        //here take form as screen forever 
		        form = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_SCRRGBFORMAT, JHI.ConstParam.GETCURRPARAM.GetHashCode()); //-1
	        }

	        { //treat rotate
		        short temp;
        		
		        temp = (short)okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_UPRIGHT, -1); //un
		        if(temp>0) {
			        temp=width;
			        width=height;
			        height=temp;
		        }
	        }
	        exSetBitmapHeader(ref bi, width, height, (short)HIWORD(form), (short)LOWORD(form));
            
            return LOWORD(form);
        }
        ushort exGetBitmapHeader(JHI.BLOCKINFO src, ref WINAPI.BITMAPINFOHEADER bi)
        {
            short width = 0, height = 0;
            long form, extend;


            //take buffer's size and screen' bitcount
            form = exGetTargetSize(src, ref width, ref height);
            extend = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_SAMPLEFIELD, -1);
            if (extend == 0)
            { //in field
                extend = okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_FIELDEXTEND, -1);
            }

            if (src.GetHashCode() <= 1)
            {
                //here take form as screen forever 
                form = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_SCRRGBFORMAT, JHI.ConstParam.GETCURRPARAM.GetHashCode()); //-1
            }

            { //treat rotate
                short temp;

                temp = (short)okDevice.SetConvertParam(JHI.ConvertParam.CONVERT_UPRIGHT, -1); //un
                if (temp > 0)
                {
                    temp = width;
                    width = height;
                    height = temp;
                }
            }
            exSetBitmapHeader(ref bi, width, height, (short)HIWORD(form), (short)LOWORD(form));

            return LOWORD(form);
        }

        //get target size 
        Int64 exGetTargetSize(JHI.TARGET tgt, ref short width, ref short height)
        {
            JHI.RECT rect = new JHI.RECT();
            Int64 form = 0;

            rect.Right = -1;
            okDevice.SetTargetRect(tgt, ref rect); //get current rect
            width = (short)(rect.Right - rect.Left);
            height = (short)(rect.Bottom - rect.Top);
            
            if (tgt == JHI.TARGET.SCREEN)
            {
                form = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_SCRRGBFORMAT, JHI.ConstParam.GETCURRPARAM.GetHashCode()); //-1
                //limit to video rect
                rect.Right = -1; //max. captured rect
                okDevice.SetTargetRect(JHI.TARGET.VIDEO, ref rect); //get video rect
                width = (short)Math.Min(width, rect.Right - rect.Left);
                height = (short)Math.Min(height, rect.Bottom - rect.Top);
            }
            else if (tgt == JHI.TARGET.BUFFER)
                form = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_BUFRGBFORMAT, JHI.ConstParam.GETCURRPARAM.GetHashCode()); //-1

            return form;
        }
        Int64 exGetTargetSize(JHI.BLOCKINFO tgt, ref short width, ref short height)
        {
            Int64 form = 0;

            //from blkinfo
            width = tgt.iWidth;
            height = Math.Abs(tgt.iHeight);


            return form;
        }

        //get size of one frame of image in buffer
        long exGetFrameSize()
        {
            long bits, size;

            size = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_BUFBLOCKSIZE, -1);
            bits = okDevice.SetCaptureParam(JHI.CaptureParam.CAPTURE_BUFRGBFORMAT, -1);
            size = (HIWORD(bits)) / 8 * LOWORD(size) * HIWORD(size);

            return size;
        }

        //set bitmap header and bitmap info if need
        long exSetBitmapHeader(ref WINAPI.BITMAPINFOHEADER bi, short width, short height, short bits, short form)
        {
            long wbytes;

            if (form == JHI.PixelFormat.FORM_RGB555.GetHashCode())
                bits = 16;
            wbytes = ((((width * bits) + 31) & ~31) >> 3);//bmp need 4 byte align

            bi.biWidth = width;
            bi.biHeight = height;

            bi.biSize = (uint)Marshal.SizeOf(typeof(WINAPI.BITMAPINFOHEADER));
            bi.biPlanes = 1;

            bi.biBitCount = (ushort)bits;
            bi.biSizeImage = (uint)wbytes * (uint)height;


            bi.biClrUsed = 0;
            //special format for 555,565 & 32 
            if (form == JHI.PixelFormat.FORM_RGB555.GetHashCode() || form == JHI.PixelFormat.FORM_RGB565.GetHashCode() || form == JHI.PixelFormat.FORM_RGB8888.GetHashCode() || form == JHI.PixelFormat.FORM_RGB8886.GetHashCode())
                bi.biCompression = WINAPI.BitmapCompressionMode.BI_BITFIELDS;
            else
                bi.biCompression = 0;
            if (bi.biCompression == WINAPI.BitmapCompressionMode.BI_BITFIELDS)
            {//
/*                DWORD* lpmask;
                lpmask = (DWORD*)((LPSTR)lpbi + lpbi->biSize);

                if (form == FORM_RGB555)
                {
                    lpmask[2] = 0x001f; //blue
                    lpmask[1] = 0x03e0;
                    lpmask[0] = 0x7c00;
                }
                else if (form == FORM_RGB565)
                {
                    lpmask[2] = 0x001f; //blue
                    lpmask[1] = 0x07e0;
                    lpmask[0] = 0xf800;
                }
                else if (bits == 32)
                {
                    lpmask[2] = 0x0000ff;
                    lpmask[1] = 0x00ff00;
                    lpmask[0] = 0xff0000;
                }*/
            }
            else if (bits <= 14)
            { // 8,10,12
                /*int i, ratio;
                RGBQUAD* lpRGB = (RGBQUAD*)((LPSTR)lpbi + lpbi->biSize);

                lpbi->biClrUsed = (1 << bits);
                ratio = lpbi->biClrUsed / 256;

                lpbi->biClrUsed = min(256, lpbi->biClrUsed); //limit
                for (i = 0; i < (short)lpbi->biClrUsed; i++)
                {
                    lpRGB[i].rgbBlue = i;//i/ratio;
                    lpRGB[i].rgbGreen = i;//i/ratio;
                    lpRGB[i].rgbRed = i;//i/ratio;
                    lpRGB[i].rgbReserved = 0;
                }*/
            }
            bi.biClrImportant = bi.biClrUsed;

            return bi.biClrUsed;
        }

        //set data to dib 
        long exSetDataToDIB(JHI.TARGET src, short start, WINAPI.BITMAPINFOHEADER lpbi, IntPtr lpdib)
        {
            JHI.BLOCKINFO blk = new JHI.BLOCKINFO();

            //get image to app buffer from tgt
            blk.lpBits = lpdib;
            blk.iWidth = (short)bi.biWidth;
            blk.iHeight = (short)(-bi.biHeight); //!!!to invert y
            blk.iBitCount = (short)bi.biBitCount;
            blk.lBlockStep = (short)bi.biSizeImage; //must be set
            blk.iHiStep = (short)HIWORD(bi.biSizeImage);

            if (bi.biCompression == WINAPI.BitmapCompressionMode.BI_BITFIELDS)
            {//
/*                DWORD* lpMask;
                lpMask = (DWORD*)((LPBYTE)lpbi + lpbi->biSize);
                if (lpMask[1] == 0x03e0) //555
                    blk.iFormType = FORM_RGB555;
                else if (lpbi->biBitCount == 16)
                    blk.iFormType = FORM_RGB565;*/
            }

            return okDevice.ConvertRect(ref blk, 0, src, start, 1);
        }

        //--demo to mask some areas just for those cards with masking capablilty   
        Boolean exDemoMask(Int32 bMaskMode)
        {
	        int			    i;
	        JHI.RECT	    rect = new JHI.RECT();
	        Byte[]		    lpMask = new Byte[40960];
	        JHI.BLOCKINFO   blk = new JHI.BLOCKINFO();
	        JHI.LOGFONT 	lfLogFont = new JHI.LOGFONT(-20, 0, 0, 0, 400, 0, 0, 0, 0, 1, 2, 1, 26, "Arial");
	        JHI.SETTEXTMODE	textmode = new JHI.SETTEXTMODE(0x0, 0xffffff, 2, 0, 0);  //


	        //1.------ overlay graph--------------------------------------------------------
	        { //set graph overlay
		        textmode.Set(0xffffff, 0x0, Convert.ToUInt32(JHI.TextModeParam.FULLCOPY.GetHashCode()), 0, 0);  //
		        JHI.POINT	pt0 = new JHI.POINT(100, 20), pt1 = new JHI.POINT(200, 120);
		        long		oldGraph = okDevice.SetVideoParam(JHI.VideoParam.VIDEO_ENABLEGRAPHS, -1);
		        IntPtr		lpGraph;
		        short		wid=0, ht=0;
		        long		stride=0;
		        JHI.RECT	rcRect = new JHI.RECT();



		        //-------capture graph overlay---------------------------------------------------

		        rcRect.Right = -1;
		        okDevice.SetTargetRect(JHI.TARGET.BUFFER, ref rcRect);

		        rcRect.Left -= 100; rcRect.Top -= 100;
		        rcRect.Right += 100; rcRect.Bottom += 100;

		        //select cap-graph frm0
		        okDevice.SetVideoParam(JHI.VideoParam.VIDEO_ENABLEGRAPHS, 0x003);
		        lpGraph = (IntPtr)okDevice.GetTargetInfo(JHI.TARGET.GRAPH, 0, ref wid, ref ht, ref stride);

                Byte[] lpBuf = new Byte[stride];
                IntPtr lpTemp;
                Array.Clear(lpBuf, 0, lpBuf.Length);

                if (lpGraph != IntPtr.Zero) //clear
                {
                    for (i = 0; i < ht; i++)
                    {
                        lpTemp = (IntPtr)(lpGraph.ToInt64() + stride * i);
                        Marshal.Copy(lpTemp, lpBuf, 0, (int)stride);
                    }
                }


		        okDevice.FillCircleTo(JHI.TARGET.GRAPH, 0, ref rcRect, 1, 0);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " JOINHOPEκ", 16); 
		        okDevice.DrawLineTo(JHI.TARGET.GRAPH, 0, pt0, pt1, 0xff);
		        rect.SetRect(200, 120, 200, 120);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " κJOINHOPE", 16); 


		        //select cap-graph frm1
		        okDevice.SetVideoParam(JHI.VideoParam.VIDEO_ENABLEGRAPHS, 0x203);
		        if (lpGraph != IntPtr.Zero) //clear
                {
                    for (i = 0; i < ht; i++)
                    {
                        lpTemp = (IntPtr)(lpGraph.ToInt64() + stride * i);
                        Marshal.Copy(lpTemp, lpBuf, 0, (int)stride);
                    }
                }

		        okDevice.FillCircleTo(JHI.TARGET.GRAPH, 0, ref rcRect, 1, 0);
		        rect.SetRect(0, 0, 0, 0);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " JOINHOPEκ", 16); 
		        okDevice.DrawLineTo(JHI.TARGET.GRAPH, 0, pt0, pt1, 0xff);
		        rect.SetRect(200, 120, 200, 120);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " κJOINHOPE", 16); 


		        //-------output graph overlay---------------------------------------------------

		        //select out-graph frm0
		        okDevice.SetVideoParam(JHI.VideoParam.VIDEO_ENABLEGRAPHS, 0x103);
		        if (lpGraph != IntPtr.Zero) //clear
                {
                    for (i = 0; i < ht; i++)
                    {
                        lpTemp = (IntPtr)(lpGraph.ToInt64() + stride * i);
                        Marshal.Copy(lpTemp, lpBuf, 0, (int)stride);
                    }
                }

		        okDevice.FillCircleTo(JHI.TARGET.GRAPH, 0, ref rcRect, 1, 0);
		        rect.SetRect(0, 0, 0, 0);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " JOINHOPEκ", 16); 
		        okDevice.DrawLineTo(JHI.TARGET.GRAPH, 0, pt0, pt1, 0xff);
		        rect.SetRect(200, 120, 200, 120);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " κJOINHOPE", 16); 


		        //select out-graph frm1
		        okDevice.SetVideoParam(JHI.VideoParam.VIDEO_ENABLEGRAPHS, 0x303);
		        if (lpGraph != IntPtr.Zero) //clear
                {
                    for (i = 0; i < ht; i++)
                    {
                        lpTemp = (IntPtr)(lpGraph.ToInt64() + stride * i);
                        Marshal.Copy(lpTemp, lpBuf, 0, (int)stride);
                    }
                }

		        okDevice.FillCircleTo(JHI.TARGET.GRAPH, 0, ref rcRect, 1, 0);
		        rect.SetRect(0, 0, 0, 0);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " JOINHOPEκ", 16); 
		        okDevice.DrawLineTo(JHI.TARGET.GRAPH, 0, pt0, pt1, 0xff);
		        rect.SetRect(200, 120, 200, 120);
		        okDevice.SetTextTo(JHI.TARGET.GRAPH, ref rect, ref lfLogFont, ref textmode, " κJOINHOPE", 16); 


		        okDevice.SetVideoParam(JHI.VideoParam.VIDEO_ENABLEGRAPHS, oldGraph); //restore 

	        }

            textmode.Set(0x0, 0xffffff, 2, 0, 0);



	        //2.------ mask graph--------------------------------------------------------
	        //1. way (to set whole rect to enable/disable)
	        //graph 1.
	        rect.Left=200;
	        rect.Top=100;
	        rect.Right=280;
	        rect.Bottom=180;
	        okDevice.SetMaskRect(ref rect, 0); //disable Big Rect video 
	        rect.InflateRect(-20, -20);	
	        okDevice.SetMaskRect(ref rect, 1); //enable Small Rect video 

	        //graph 2.
	        rect.SetRect(0, 200, 200, 201);
	        okDevice.SetMaskRect(ref rect, 0);  //D ---
	        rect.SetRect(0, 202, 200, 203);
	        okDevice.SetMaskRect(ref rect, 0);  //D ---
	        rect.SetRect(0, 205, 200, 206);
	        okDevice.SetMaskRect(ref rect, 0);  //D ---



	        //2. way (to set mask rect with each pixel setting)

	        //graph 3.
            Array.Clear(lpMask, 0, 20000); //clear bits 
	        for(i=20;i<80;i++)
		        lpMask[100+i]=1;		//E ~~~

	        for(i=1;i<99;i++)
		        lpMask[100*50+i]=1;		//E ---
	        for(i=1;i<99;i++)
		        lpMask[i*100+50]=1;		//E  |

	        for(i=0;i<=99;i++) {
		        lpMask[i*100+i]=1;		//E  /
	        }
	        rect.SetRect(10, 310, 110, 410); //Disable Rect with + \ ~
	        okDevice.SetMaskRect(ref rect, ref lpMask[0]);

	        //graph 4.
            for (i = 0; i < 40000; i++)
                lpMask[i] = 1;
	        for(i=1;i<99;i++)
		        lpMask[5000+i]=0;		//D ---
	        for(i=1;i<99;i++)
		        lpMask[i*100+50]=0;		//D  |
	        rect.SetRect(200, 319, 300, 419);	 //disable +
	        okDevice.SetMaskRect(ref rect, ref lpMask[0]);


	        //example to set char
	        {
		        rect.SetRect(0, 0, 0, 0);


                for (i = 0; i <= 40000; i++)
                {
                    lpMask[i] = 1;
                }
                blk.lpBits = (IntPtr)@lpMask[0];
		        blk.iBitCount=8;
		        blk.iWidth=100;
		        blk.iHeight=30; 
		        okDevice.SetTextTo(ref blk, ref rect, ref lfLogFont, ref textmode, "κ", 8); 

		        rect.SetRect(300,200,300+100,200+40);	 //set characters
		        okDevice.SetMaskRect(ref rect, ref lpMask[0]);


                for (i = 0; i <= 40000; i++)
                {
                    lpMask[i] = 1;
                }
                rect.SetRect(0, 0, 0, 0);	 //set characters
		        okDevice.SetTextTo(ref blk, ref rect, ref lfLogFont, ref textmode, "JoinHope", 8); 
		        rect.SetRect(300, 240, 300+100, 240+40);	 //set chinese characters
		        okDevice.SetMaskRect(ref rect, ref lpMask[0]);


	        }
/*
	        //example to set char and graphics by way of windows hdc
	        {
		        HANDLE	hDCBitmap;
		        HDC		hdcMem;
		        RECT	rect= {0,0,200,100};

		        FillMemory(lpMask,40000,1); //set bits to init 
		        blk.lpBits=lpMask;
		        blk.iBitCount=8;
		        blk.iWidth=200;
		        blk.iHeight=100; 

		        hdcMem=okCreateDCBitmap( hBoard, (TARGET)&blk, &hDCBitmap);

		        SetTextColor(hdcMem,0xffffff); //cf
		        SetBkColor(hdcMem,0); //cf
		        TextOut(hdcMem,100,0,"7123456",7);
		        MoveToEx(hdcMem,100,100,NULL);
		        LineTo(hdcMem,200,500);
		        Ellipse(hdcMem,0,0,200,100);

		        okMapDCBitmapTo(hDCBitmap,0);

		        okFreeDCBitmap(hDCBitmap);

		        okSetMaskRect(hBoard,&rect,lpMask);

	        }					
            */
	        //turn on mask
	        okDevice.EnableMask(bMaskMode); //1 positive mask

	        return true;
        }

        //--demo to set color/gray bands to buffer and dib
        Boolean exSetTestBands(IntPtr lpLinear, short bits, short height, long stride)
        { //set gray and color bands to dib and buffer 0
            int i, j, k, m;
            short offx, offy, step = (short)(bits / 8);
            short bwid = (short)(32 * bits / 8), halfx = (short)(stride / 2 / bits * bits), endx = (short)(stride - step + 1);
            Byte value, red, green, blue;
            float fK;

            Byte[]    data = new Byte[stride];

            //set bands.  suppose buffer as format of 24 bits 
            
            if (lpLinear == IntPtr.Zero)
                return false;

            for (i=0; i<stride; i++)
                data[i] = 0;
            for (i = 0; i < height; i++)  //clear whole zero
                Marshal.Copy(data, 0, (IntPtr)(lpLinear.ToInt64() + stride * i), (int)stride);

            //-------------------------------------------------------
            // down half section (gray level section)
            //
            offy = (short)Math.Min(256, height / 2);
            for (i = offy; i < height; i++)
            {
                for (j = 0; j < stride / 3; j += step)
                {
                    k = j / step;
                    k |= (k << 8) | (k << 16);
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), k);
                }
                 

                for (k = 0, j = (int)(1 * stride / 3); j < 2 * stride / 3; j += 24 * 4, k += 32)
                { //midle 1/3 section
                    if (k == 256)
                        k = 255;
                    for (m = 0; m < 24 * 4; m++)
                        Marshal.WriteByte((IntPtr)(lpLinear.ToInt64() + stride * i + j + m), (byte)k);
                }

                for (m = 0; m < stride / 3; m++)
                    Marshal.WriteByte((IntPtr)(lpLinear.ToInt64() + stride * i + 2 * stride / 3 + m), (byte)(i - offy));    //right 1/3 section
            }
            
            //1black
            offy = 0;
            //1black
            for (i = offy; i < offy + 32; i++)
            {		//right half lines
                for (j = halfx; j <= endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0);
            }
            offy = (short)i;
            
            //1black
            offx = 0;
            for (i = 0; i < Math.Min(256, height / 2); i++)
            {	//left half lines
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0);
                }
            }
            
            //2blue
            for (i = offy; i < offy + 32; i++)
            {	  //right
                value = 255;
                for (j = halfx; j < halfx + 128 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), value); //0xff;
                    value -= 2;
                }

                value = 255;
                for (j = halfx + 128 * step; j < halfx + 256 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0x3f3f00) | (value--));
                }

                value = 127;
                for (j = halfx + 256 * step; j < endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0xdf) | (value << 16) | ((value--) << 8));
            }
            offy = (short)i;
            
            //2blue
            offx += bwid;
            for (i = 0; i < Math.Min(256, height / 4); i++)
            {   //left top section
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff);
                }
            }

            //added on 20181220
            for (i = 64; i < Math.Min(128, height / 4); i++)
            {   //left, middle
                fK = (float)(i - 63) / 16;
                blue = (Byte)(63 * fK + 0.5);
                red = green = (Byte)(8 * fK + 0.5);
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (blue) | (green << 8) | (red << 16));
                }
            }

            value = 1; //added on 20180517
            for (i = 128; i < Math.Min(256, height / 2); i++)
            {   //left  half down section
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0x7f | (value << 16) | (value << 8));
                }
                value += 2;
            }

            
            //3green  
            for (i = offy; i < offy + 32; i++)
            {  //right
                value = 255;
                for (j = halfx; j < halfx + 128 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (value) << 8);
                    value -= 2;
                }

                value = 255;
                for (j = halfx + 128 * step; j < halfx + 256 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0x3f003f) | ((value--) << 8));
                }

                value = 127;
                for (j = halfx + 256 * step; j < endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0xdf00) | (value << 16) | ((value--)));
            }
            offy = (short)i;

            //3green
            offx += bwid;
            for (i = 0; i < Math.Min(256, height / 4); i++)
            {    //left
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff00);
                }
            }
            //added on 20181220
            for (i = 64; i < Math.Min(128, height / 4); i++)
            {   //left, middle
                fK = (float)(i - 63) / 16;
                green = (Byte)(63 * fK + 0.5);
                red = blue = (Byte)(8 * fK + 0.5);
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (blue) | (green << 8) | (red << 16));
                }
            }

            value = 1; //added on 20180517
            for (i = 128; i < Math.Min(256, height / 2); i++)
            {   //left 2. section
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0x7f00 | (value << 16) | (value));
                }
                value += 2;
            }


            //4red
            for (i = offy; i < offy + 32; i++)
            {  //right
                value = 255;
                for (j = halfx; j < halfx + 128 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (value) << 16); //0xff0000;
                    value -= 2;
                }
                value = 255;
                for (j = halfx + 128 * step; j < halfx + 256 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0x3f3f) | ((value--) << 16));
                }

                value = 127;
                for (j = halfx + 256 * step; j < endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0xdf0000) | (value << 8) | ((value--)));
            }
            offy = (short)i;

            //4red
            offx += bwid;
            for (i = 0; i < Math.Min(256, height / 4); i++)
            {  //left
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff0000);
                }
            }
            //added on 20181220
            for (i = 64; i < Math.Min(128, height / 4); i++)
            {   //left, middle
                fK = (float)(i - 63) / 16;
                red = (Byte)(63 * fK + 0.5);
                green = blue = (Byte)(8 * fK + 0.5);
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (blue) | (green << 8) | (red << 16));
                }
            }
            value = 1; //added on 20180517
            for (i = 128; i < Math.Min(256, height / 2); i++)
            {   //left 2. section
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0x7f0000 | (value << 8) | (value));
                }
                value += 2;
            }


            //5cyan
            for (i = offy; i < offy + 32; i++)
            {  //right
                value = 255;
                for (j = halfx; j < halfx + 128 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (((value)) << 8) | (value));
                    value -= 2;
                }
                value = 255;
                for (j = halfx + 128 * step; j < halfx + 256 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0x3f0000) | ((value) << 8) | ((value--)));
                }

                value = 127;
                for (j = halfx + 256 * step; j < endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0xdfdf) | ((value--) << 16));
            }
            offy = (short)i;

            //5cyan
            offx += bwid;
            for (i = 0; i < Math.Min(256, height / 4); i++)
            { //left
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xffff);
                }
            }
            //added on 20181220
            for (i = 64; i < Math.Min(128, height / 4); i++)
            {   //left, middle
                fK = (float)(i - 63) / 16;
                green = blue = (Byte)(63 * fK + 0.5);
                red = (Byte)(8 * fK + 0.5);
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (blue) | (green << 8) | (red << 16));
                }
            }
            value = 1; //added on 20180517
            for (i = 128; i < Math.Min(256, height / 2); i++)
            {   //left 2. section
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0x7f7f | (value << 16));
                }
                value += 2;
            }


            //6magenta
            for (i = offy; i < offy + 32; i++)
            {    //right
                value = 255;
                for (j = halfx; j < halfx + 128 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (((value)) << 16) | (value));
                    value -= 2;
                }
                value = 255;
                for (j = halfx + 128 * step; j < halfx + 256 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0x3f00) | ((value) << 16) | (value--));
                }

                value = 127;
                for (j = halfx + 256 * step; j < endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0xdf00df) | ((value--) << 8));
            }
            offy = (short)i;

            //6magenta
            offx += bwid;
            for (i = 0; i < Math.Min(256, height / 4); i++)
            { //left 
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff00ff);
                }
            }
            //added on 20181220
            for (i = 64; i < Math.Min(128, height / 4); i++)
            {   //left, middle
                fK = (float)(i - 63) / 16;
                red = blue = (Byte)(63 * fK + 0.5);
                green = (Byte)(8 * fK + 0.5);
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (blue) | (green << 8) | (red << 16));
                }
            }
            value = 1; //added on 20180517
            for (i = 128; i < Math.Min(256, height / 2); i++)
            {   //left 2. section
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0x7f007f | (value << 8));
                }
                value += 2;
            }

            //7yellow
            for (i = offy; i < offy + 32; i++)
            {  //right
                value = 255;
                for (j = halfx; j < halfx + 128 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (((value)) << 16) | ((value) << 8));
                    value -= 2;
                }
                value = 255;
                for (j = halfx + 128 * step; j < halfx + 256 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0x3f) | ((value) << 16) | ((value--) << 8));
                }

                value = 127;
                for (j = halfx + 256 * step; j < endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (0xdfdf00) | (value--));
            }
            offy = (short)i;

            //7yellow
            offx += bwid;
            for (i = 0; i < Math.Min(256, height / 4); i++)
            { //left
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xffff00);
                }
            }
            //added on 20181220
            for (i = 64; i < Math.Min(128, height / 4); i++)
            {   //left, middle
                fK = (float)(i - 63) / 16;
                red = green = (Byte)(63 * fK + 0.5);
                blue = (Byte)(8 * fK + 0.5);
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (blue) | (green << 8) | (red << 16));
                }
            }
            value = 1; //added on 20180517
            for (i = 128; i < Math.Min(256, height / 2); i++)
            {   //left 2. section
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0x7f7f00 | (value));
                }
                value += 2;
            }

            //8white
            for (i = offy; i < offy + 32; i++)
            {  //right
                value = 255;
                for (j = halfx; j < halfx + 128 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), (((value)) << 16) | ((value) << 8) | (value));
                    value -= 2;
                }
                value = 255;
                for (j = halfx + 128 * step; j < halfx + 256 * step; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), ((value) << 16) | ((value) << 8) | (value--));
                }

                for (j = halfx + 256 * step; j < endx; j += step)
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xdfdfdf);
            }
            offy = (short)i;

            //8white
            offx += bwid;
            for (i = 0; i < Math.Min(256, height / 2); i++)
            {
                for (j = offx; j < offx + bwid; j += step)
                {
                    Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xffffff);
                }
            }

            //--single pixel color line
            offx += bwid;
            offx += (short)(bwid / 2); // blue vertical line
            for (i = 0; i < Math.Min(128, height / 4); i++)
            {
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + offx), 0xff);
            }

            offy = 128 + 16;
            i = offy;
            for (j = bwid * 8; j < halfx - 1; j += step)
            {// blue horizontal line 
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff);
            }

            //--
            offx += (short)(bwid / 2);// green vertical line
            for (i = 0; i < Math.Min(128, height / 4); i++)
            {
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + offx), 0xff00);
            }

            offy += 16;
            i = offy;
            for (j = bwid * 8; j < halfx - 1; j += step)
            {// green horizontal line 
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff00);
            }


            //--
            offx += (short)(bwid / 2); //red vertical line
            for (i = 0; i < Math.Min(128, height / 4); i++)
            {
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + offx), 0xff0000);
            }

            offy += 16;
            i = offy;
            for (j = bwid * 8; j < halfx - 1; j += step)
            {// red horizontal line 
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff0000);
            }


            //--
            offx += (short)(bwid / 2); //cyan vertical line
            for (i = 0; i < Math.Min(128, height / 4); i++)
            {
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + offx), 0x00ffff);
            }

            offy += 16;
            i = offy;
            for (j = bwid * 8; j < halfx - 1; j += step)
            {// cyan horizontal line 
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0x00ffff);
            }


            //--
            offx += (short)(bwid / 2); //magenta vertical line
            for (i = 0; i < Math.Min(128, height / 4); i++)
            {
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + offx), 0xff00ff);
            }

            offy += 16;
            i = offy;
            for (j = bwid * 8; j < halfx - 1; j += step)
            {// magenta horizontal line 
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xff00ff);
            }

            //--
            offx += (short)(bwid / 2); //yellow vertical line
            for (i = 0; i < Math.Min(128, height / 4); i++)
            {
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + offx), 0xffff00);
            }

            offy += 16;
            i = offy;
            for (j = bwid * 8; j < halfx - 1; j += step)
            {// yellow horizontal line 
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xffff00);
            }


            //--
            offx += (short)(bwid / 2); //white vertical line
            for (i = 0; i < Math.Min(128, height / 4); i++)
            {
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + offx), 0xffffff);
            }

            offy += 16;
            i = offy;
            for (j = bwid * 8; j < halfx - 1; j += step)
            {// white horizontal line 
                Marshal.WriteInt32((IntPtr)(lpLinear.ToInt64() + stride * i + j), 0xffffff);
            }


            Array.Resize(ref data, (int)(stride / 2 - offx));

            //repeat
            offx += bwid;
            while (stride / 2 > offx)
            {//remain 	
                for (i = 0; i < Math.Min(256, height / 2); i++)
                {
                    Marshal.Copy((IntPtr)(lpLinear.ToInt64() + stride * i + bwid), data, 0, (int)(stride / 2 - offx));
                    Marshal.Copy(data, 0, (IntPtr)(lpLinear.ToInt64() + stride * i + offx), (int)(stride / 2 - offx));
                }
                offx += (short)(bwid * 8);
            }


            return true;
        }

        //up-down image data for dib
        Boolean exConvertBitmap(WINAPI.BITMAPINFOHEADER bi, IntPtr lpdib)
        {
            long i, wbytes;
            IntPtr lptop, lpbottom;

            if (bi.biHeight == 0)
                return false;
            //inverse dib (top to bottom)
            wbytes = bi.biSizeImage / bi.biHeight;
            Byte[] lpbuf = new Byte[wbytes];
            Byte[] lpTemp = new Byte[wbytes];

            lptop = lpdib;
            lpbottom = (IntPtr)(lpdib.ToInt64() + (Int64)((bi.biHeight - 1) * wbytes));
            for (i = 0; i < (bi.biHeight / 2); i++)
            {
                Marshal.Copy(lptop, lpbuf, 0, (int)wbytes);
                Marshal.Copy(lpbottom, lpTemp, 0, (int)wbytes);
                Marshal.Copy(lpTemp, 0, lptop, (int)wbytes);
                Marshal.Copy(lpbuf, 0, lpbottom, (int)wbytes);
                lptop = (IntPtr)(lptop.ToInt64() + wbytes);
                lpbottom = (IntPtr)(lpbottom.ToInt64() - wbytes);
            }
            
            return true;
        }

        //--demo to set current capture rect on screen. mode=0: left-top, 1:centerize
        long exSetToWndRectEx(long lMode)
        {
            short iHBar, iVBar;
            UInt32 dwWinStyle;
            long lSize = 0, lHScrMax, lVScrMax;
            JHI.RECT rect;
//            SCROLLINFO scrinfo;
            /*
            if (!IsWindow(hWnd))
                return FALSE;
            if (IsIconic(hWnd))
                return FALSE;

            //get client rect
            GetClientRect(hWnd, &rect);

            iHBar = GetSystemMetrics(SM_CYHSCROLL);
            iVBar = GetSystemMetrics(SM_CXHSCROLL);
            dwWinStyle = GetWindowLong(hWnd, GWL_STYLE);
            if (dwWinStyle & WS_HSCROLL)
                rect.bottom += iHBar;
            if (dwWinStyle & WS_VSCROLL)
                rect.right += iVBar;

            if ((sampwidth <= rect.right) &&
                    (sampheight <= rect.bottom))
            { //no bars
                lHScrMax = 0;
                lVScrMax = 0;
            }
            else if ((sampwidth + iVBar) <= rect.right)
            { //surely no h bar
                lHScrMax = 0;
                rect.right -= iVBar;
                lVScrMax = sampheight - rect.bottom;
            }
            else if ((sampheight + iHBar) <= rect.bottom)
            { //surely no v bar
                lHScrMax = sampwidth - rect.right;
                lVScrMax = 0;
                rect.bottom -= iHBar;
                //horzstart=lHScrMax+1;
            }
            else
            { //with two bars
                rect.right -= iVBar;
                rect.bottom -= iHBar;
                lHScrMax = sampwidth - rect.right;
                lVScrMax = sampheight - rect.bottom;
            }

            scrinfo.cbSize = sizeof(SCROLLINFO);
            scrinfo.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;// SIF_ALL;

            //------------------horz
            GetScrollInfo(hWnd, SB_HORZ, &scrinfo);
            scrinfo.nMin = 0;
            scrinfo.nPage = 1;
            scrinfo.nTrackPos = 0;
            scrinfo.nMax = 0;

            if ((lHScrMax > 0) && (bMatchClient == 0))
            {  //with scroll bar, and no stretch
                scrinfo.nPage = rect.right & ~1;
                //WndScrollControl(hWnd, message, LOWORD(wParam),HIWORD(wParam), bActive);
                scrinfo.nMax = scrinfo.nPage + lHScrMax - 1;
            }
            horzstart = min(horzstart, scrinfo.nMax - scrinfo.nPage + 1);
            scrinfo.nTrackPos = scrinfo.nPos = horzstart;
            SetScrollInfo(hWnd, SB_HORZ, &scrinfo, TRUE);//redraw


            //----------vert
            GetScrollInfo(hWnd, SB_VERT, &scrinfo);
            scrinfo.nMin = 0;
            scrinfo.nPage = 1;
            scrinfo.nTrackPos = 0;
            scrinfo.nMax = 0;
            if ((lVScrMax > 0) && (bMatchClient == 0))
            {  //with scroll bar, and no stretch
                scrinfo.nPage = rect.bottom;
                scrinfo.nMax = scrinfo.nPage + lVScrMax - 1;
            }
            vertstart = min(vertstart, scrinfo.nMax - scrinfo.nPage + 1);
            scrinfo.nTrackPos = scrinfo.nPos = vertstart;
            SetScrollInfo(hWnd, SB_VERT, &scrinfo, TRUE); //redraw

            okSetCaptureParam(hBoard, CAPTURE_SCROFFSETVID, MAKELONG(horzstart, vertstart));


            okSetToWndRect(hBoard, hWnd); //set hWnd of main process to hBoard 
            if (lMode == 1)
            { //if set to center
                if ((rect.right) > sampwidth)
                    rect.left = ((rect.right - sampwidth) / 2);//& (~0x3);
                if ((rect.bottom) > sampheight)
                    rect.top = ((rect.bottom - sampheight) / 2);
            }

            //make offset x,y
            lSize = MAKELONG(rect.left, rect.top);
            rect.right = rect.left + min(sampwidth, rect.right);
            rect.bottom = rect.top + min(sampheight, rect.bottom);

            //map to absolute screen rect
            MapWindowPoints(hWnd, HWND_DESKTOP, (LPPOINT) & rect, 2);

            if (bMatchClient == 0) //need not to match client rect
                okSetTargetRect(hBoard, SCREEN, &rect);

*/
            return lSize;

        }

        //display current dib info on windows title section
        void exDisplayDIBInfo()
        {

            String	strTemp;
            int     iIndex;


            strTemp = Text;
            iIndex = strTemp.IndexOf('-');

            if (iIndex > 0)
            {
                //if( (lpstr-string)>35)
	              //  lpstr=string+35;
                strTemp.Remove(iIndex);
            }
            strTemp = strTemp + "- " + bi.biWidth.ToString() + "x" + bi.biHeight.ToString() + "x" + bi.biBitCount.ToString();
            if (bi.biWidth > 0)
	            Text = strTemp;

        }

        Boolean exLoadImageFile()
        {
	        String		szFileName = "";
	        long		total;
	        long		length=1;
	        JHI.BLOCKINFO	blkinfo = new JHI.BLOCKINFO();
        	

	        if(!exGetLoadName(ref szFileName))
		        return false;
            
	        if( szFileName.IndexOf('.') == -1)
		        return false;
            
	        if( (szFileName.IndexOf(".seq") != -1) ||
			        (szFileName.IndexOf(".avi") != -1) ||
				        (szFileName.IndexOf(".m2v") != -1)
			        ) {
		        //first get inf about seq file 		
		        total = okDevice.LoadImageFile(szFileName, 0, ref blkinfo, 0, 0);//no=0

		        //how many
                SetSeqFileNumBox seqBox = new SetSeqFileNumBox();
                seqBox.SetFileNum(total);
		        length=total;
    	        if( seqBox.ShowDialog() == DialogResult.OK ) {
                    total = seqBox.GetFileNum();
        			
			        //then load them into buffer
                    length = okDevice.LoadImageFile(szFileName, 0, JHI.TARGET.BUFFER, 0, total);
			        if ( length > 0 ) {
				        //last set first block to dib
				        JHI.EXTRAFRMINFO	extraInfo = new JHI.EXTRAFRMINFO(); //


				        //buffer size changed
				        if( exAllocateDIBMemory() == 0) {
						        return false;
				        }

                        okDevice.GetCurrImageInfo(ref extraInfo, Marshal.SizeOf(typeof(JHI.EXTRAFRMINFO)));

				        exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi); 
				        exSetDataToDIB(JHI.TARGET.BUFFER, 0, bi, lpdib);
			        }
                    
		        }
	        }
	        else {
		        if(okDevice.GetBufferSize(IntPtr.Zero, ref dwBufSize) != 0 ) { //buffer being
			        long	lNum=1;
			        JHI.RAWFILEPARAM sRawFile = new JHI.RAWFILEPARAM();

                    blkinfo.lpBits = IntPtr.Zero; //only get block info
                    if (szFileName.IndexOf(".raw") != -1)
                    {
                        if (okDevice.LoadImageFile(szFileName, ref sRawFile, ref blkinfo, 0, 1) < 0)
                            return false;
                    }
                    else
                    {
                        if (okDevice.LoadImageFile(szFileName, 0, ref blkinfo, 0, 1) < 0)
                            return false;
                    }
                    
			        if(sRawFile.wPixBits != 0) //filled
				        sRawFile.wRawFlag = (ushort)JHI.ConstParam.RAWFILE.GetHashCode();


                    //how many
                    SetSeqFileNumBox seqBox = new SetSeqFileNumBox();
                    seqBox.SetFileNum(lNum);
                    if (seqBox.ShowDialog() == DialogResult.OK)
                    {
                        lNum = seqBox.GetFileNum();

                        if (szFileName.IndexOf(".raw") != -1)
                        {
                            length = okDevice.LoadImageFile(szFileName, ref sRawFile, JHI.TARGET.BUFFER, 0, lNum);
                        }
                        else
                        {
                            length = okDevice.LoadImageFile(szFileName, 0, JHI.TARGET.BUFFER, 0, lNum);
                        }

				        //then load them into buffer
				        if ( length > 0 ) {
					        //buffer size changed
					        if( exAllocateDIBMemory() == 0) {
							        return false;
					        }

					        //last set first block to dib
					        exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi); 
					        exSetDataToDIB(JHI.TARGET.BUFFER, 0, bi, lpdib);
				        }
			        }
                }
		        else if(okDevice.isOpen()) { // no buffer
			        //way 2

			        blkinfo.lpBits = IntPtr.Zero; //only get block info
			        okDevice.LoadImageFile(szFileName, 0, ref blkinfo, 0, 1);
                    
			        // set dib info	
			        exGetBitmapHeader(blkinfo, ref bi);
			        //buffer size changed
			        if( exAllocateDIBMemory() == 0 ) {
				        return false;
			        }

			        //get dib for wnd paint
			        blkinfo.lpBits=lpdib;
			        //blkinfo.lpExtra=(LPBYTE)lpbi+lpbi->biSize;  //do here
                    blkinfo.lpExtra = IntPtr.Zero;  //do here
                    length = okDevice.LoadImageFile(szFileName, 0, ref blkinfo, 0, 1);
                    if (length > 0)
                    {
				        exConvertBitmap(bi,lpdib); //invert y
			        }
		        }
	        }

	        if (length==0)
		        MessageBox.Show(" Load file failed ?!  Try to check the file or memory size. ", "Warning !", System.Windows.Forms.MessageBoxButtons.OK); 

	        return true;
        }

        //load image file to buffer and screen (support bmp, raw, seq)

        Boolean exGetLoadName(ref String szFileName)
        {
            openFileDialog1.Filter = "BMP file  (*.BMP)|*.BMP|Jpeg format file (*.JPG,JPEG)|*.JPG;*.JPEG|Sequence file  (*.SEQ)|*.SEQ|Audio-video interleaved (*.AVI)|*.AVI|Mpeg2 Video stream (*.M2V)|*.M2V|Jpeg2000 format file (*.JP2)|*.JP2|TIFF file  (*.TIF)|*.TIF|GIF file  (*.GIF)|*.GIF|Raw format files (*.RAW)|*.RAW|All Above format files |*.BMP;*.JPG;*.JPEG;*.SEQ;*.AVI;*.M2V;*.JP2;*.TIF;*.GIF;*.RAW";
            openFileDialog1.FilterIndex = 11;

            if (openFileDialog1.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                return false;

            szFileName = openFileDialog1.FileName;

	        return true;

        }

        Boolean exEndCaptureAudio()
        {
            if (okDevice.isAudioOpen())
            {
                String str;
                elapsedtimes = JHI.okApi.GetTickCount() - elapsedtimes;
                str = " Stoped ! captured times = " + elapsedtimes.ToString() + " ms";
                Text = str;

                okDevice.StopCaptureAudio();
                okDevice.CloseAudio();

                //way1 and way2 end file

            }

            return true;
        }

        private void FileZeroAllBuffer_Click(object sender, EventArgs e)
        {
            Int64   number;
            IntPtr  lpCurrBase = IntPtr.Zero;
            int   i; 
            number = okDevice.GetBufferSize(ref lpCurrBase, ref dwBufSize); //current

            if (lpCurrBase != IntPtr.Zero)
            {
                for (i = 0; (ulong)i < dwBufSize; i++)
                    Marshal.WriteByte((IntPtr)(lpCurrBase.ToInt64() + i), 0);
            }
            exGetBitmapHeader(JHI.TARGET.BUFFER, ref bi);
            SetBlockInfo();
            PainttoScreen(0);
        }

        private void OptionCenterScreen_Click(object sender, EventArgs e)
        {

        }

    }

}
